/* global lqMobileModule */
/* jshint maxparams: 10 */
lqMobileModule.controller('bookingGuestInfoController',
  [
    '$scope',
    '$rootScope',
    'events',
    'bookingModelService',
    'routingService',
    'returnsUserProfileModel',
    'reservationsModel',
    'Profile',
    'satelliteTrackingModelService',
    'hotelInformationModel',
    function ($scope,
      $rootScope,
      events,
      bookingModelService,
      routingService,
      returnsUserProfileModel,
      reservationsModel,
      Profile,
      satelliteTrackingModelService,
      hotelInformationModel
    ) {
      'use strict';

      $scope.isUserLogged = returnsUserProfileModel.isLoggedIn();

      $scope.guestInfoForm = {};
      $scope.guestInfoForm.formSubmitted = false;
      $scope.hotelInfo = hotelInformationModel.data.hotelDetails;

      $scope.guestInfoForm.submitForm = function (isFormValid) {
        var profile;

        $scope.guestInfoForm.formSubmitted = true;
        $scope.guestInfoForm.submitDisabled = true;

        if (isFormValid) {
          if ($scope.bookingForm.joinReturns) {
            profile = Profile.build();

            if (typeof bookingModelService.data.firstName === 'string') {
              bookingModelService.data.firstName = bookingModelService.data.firstName.trim();
            }
            profile.firstName = bookingModelService.data.firstName;

            if (typeof bookingModelService.data.lastName === 'string') {
              bookingModelService.data.lastName = bookingModelService.data.lastName.trim();
            }
            profile.lastName = bookingModelService.data.lastName;

            profile.zipCode = bookingModelService.data.zipCode;
            profile.mobilePhone = bookingModelService.data.mobilePhone;

            if (typeof bookingModelService.data.emailAddress === 'string') {
              bookingModelService.data.emailAddress = bookingModelService.data.emailAddress.trim();
            }
            profile.emailAddress = bookingModelService.data.emailAddress;

            $scope.bookingForm.creatingUserProfilePromess = returnsUserProfileModel.createUserProfile(profile, '0' + profile.zipCode);
          }
          bookingModelService.persistData();
          routingService.goToBookingGuarantee();
          $scope.guestInfoForm.submitDisabled = false;
        }
        $scope.guestInfoForm.submitDisabled = false;
      };

      $scope.useThisInfoStateChange = function () {
        if ($scope.bookingForm.joinReturns) {
          satelliteTrackingModelService.useThisInfoToJoinLQSelected();
        }
      };

      satelliteTrackingModelService.bookingGuestInfoLoaded($scope.hotelInfo.hotelId);
    }
  ]);
