/* global lqMobileModule */
lqMobileModule.controller('CarouselDemoCtrl', function ($scope) {
  'use strict';

  var slides = $scope.slides = [];
  $scope.myInterval = 5000;
  $scope.addSlide = function (image, link, target) {
    slides.push({
      image: image,
      link: link,
      target: target
    });
  };

  $scope.init = function (data, interval) {
    $scope.myInterval = interval;
    var i,
      onTime,
      offTime,
      currTime;
    for (i = 0; i < data.length; i += 1) {
      onTime = null;
      offTime = null;
      currTime = new Date();
      if (data[i].onTime !== '') {
        onTime = new Date(data[i].onTime);
      }
      if (data[i].offTime !== '') {
        offTime = new Date(data[i].offTime);
      }
      if ((onTime === null && offTime === null) ||
                    (onTime < currTime && currTime < offTime)) {
        $scope.addSlide(data[i].image, data[i].link, data[i].target);
      }
    }
  };
});
