/* global lqMobileModule*/
lqMobileModule.factory('hotelNearbyPlacesModel', ['$q', 'hotelInformationEndpointService',
  function ($q, hotelInformationEndpointService) {
    'use strict';

    var dataModel = {
      data: {
        hotelNearbyPlaces: [],
        hotelNearbyPlacesPromises: [],
        selectedHotelNearbyPlaces: [],
        selectedCategory: ''
      }
    };

    dataModel.loadHotelNearbyPlaces = function (hotelId, lat, log, category) {
      if (!dataModel.data.hotelNearbyPlaces[hotelId]) {
        dataModel.data.hotelNearbyPlaces[hotelId] = [];
        dataModel.data.hotelNearbyPlacesPromises[hotelId] = [];
      }
      if (!dataModel.data.hotelNearbyPlaces[hotelId][category]) {
        dataModel.data.hotelNearbyPlacesPromises[hotelId][category] =
          hotelInformationEndpointService.getHotelNearbyPlaces(lat, log, category);
        return dataModel.data.hotelNearbyPlacesPromises[hotelId][category].then(
                function (response) {
                  if (response.data === '') {
                    throw 'Could not retrieve hotel reviews';
                  }
                  dataModel.data.hotelNearbyPlaces[hotelId][category] = response.data.businesses;
                  dataModel.data.selectedHotelNearbyPlaces =
                    dataModel.data.hotelNearbyPlaces[hotelId][category];
                },
                function () {
                  throw 'Could not retrieve hotel reviews';
                }
            );
      }
      return dataModel.data.hotelNearbyPlacesPromises[hotelId];
    };

    dataModel.setSelectedHotelNearbyPlaces = function (nearbyPlaces) {
      dataModel.data.selectedHotelNearbyPlaces = nearbyPlaces;
    };

    dataModel.setSelectedCategory = function (category) {
      dataModel.data.selectedCategory = category;
    };

    return dataModel;
  }]);
