/* global lqMobileModule*/
lqMobileModule.factory('hotelReviewsModel', ['$q', 'hotelInformationEndpointService',
  function ($q, hotelInformationEndpointService) {
    'use strict';

    var dataModel = {
      data: {
        hotelReviews: [],
        hotelReviewsPromises: [],
        selectedHotelReviews: {}
      }
    };

    dataModel.loadHotelReviews = function (hotelId) {
      if (!dataModel.data.hotelReviewsPromises[hotelId]) {
        dataModel.data.hotelReviewsPromises[hotelId] =
          hotelInformationEndpointService.getHotelReviews(hotelId);
        return dataModel.data.hotelReviewsPromises[hotelId].then(
                function (response) {
                  if (response.data === '') {
                    throw 'Could not retrieve hotel reviews';
                  }
                  dataModel.data.hotelReviews[hotelId] = response.data;
                  dataModel.data.selectedHotelReviews = dataModel.data.hotelReviews[hotelId];
                },
                function () {
                  throw 'Could not retrieve hotel reviews';
                }
            );
      }
      return dataModel.data.hotelReviewsPromises[hotelId];
    };

    dataModel.setSelectedHotelReviews = function (reviews) {
      dataModel.data.selectedHotelReviews = reviews;
    };

    return dataModel;
  }]);
