/* global lqMobileModule*/
lqMobileModule.factory('localInfoModelService', ['persistentStorageModelService',
  function (persistentStorageModelService) {
    'use strict';

    var modelService = {};

    modelService.data = {
      previousSearches: []
    };

    modelService.addPreviousSearch = function (search) {
      var previousSearches = modelService.data.previousSearches;
      if (!previousSearches.contains(search)) {
        if (previousSearches.length > 4) {
          previousSearches.pop();
        }
        previousSearches.unshift(search);
        persistentStorageModelService.setPreviousSearches(modelService.data.previousSearches);
        modelService.data.previousSearches = previousSearches;
      }
    };

    function loadDefaultData() {
      persistentStorageModelService.getPreviousSearches().then(
        function (previousSearches) {
          if (previousSearches !== null) {
            modelService.data.previousSearches = previousSearches;
          }
        },
        function () {
          if (previousSearches !== null) {
            modelService.data.previousSearches = [];
          }
        }
      );
    }

    loadDefaultData();

    return modelService;
  }]);
