/* global angular, routing, defaultTemplate, Modernizr, lqmobileConfigs, $*/
var lqMobileModule = angular.module('lqMobile', ['ngRoute', 'ngStorage', 'ui.bootstrap', 'ngTouch', 'ngLodash', 'gm.datepickerMultiSelect', 'ngMap', 'ngIdle', 'ngSanitize']);

lqMobileModule.constant('Modernizr', Modernizr);

lqMobileModule.config(function ($sceDelegateProvider) {
  $sceDelegateProvider.resourceUrlWhitelist([
    'self',
    lqmobileConfigs.httpBase + '**'
  ]);
});


lqMobileModule.config(['IdleProvider', function (IdleProvider) {
  IdleProvider.idle(5);
  IdleProvider.timeout(lqmobileConfigs.timeout);
}]);

lqMobileModule.config(['$routeProvider',
  function ($routeProvider) {
    'use strict';

    $routeProvider
            .when('/home', {
              templateUrl: lqmobileConfigs.httpBase + '/content/lq/lq-mobile-app-wrapper2/' + lqmobileConfigs.currentLocale + '/findandbook/home710.content.html' + routing,
              // templateUrl: './test/home.content.html',
              controller: 'homePartialController',
              reloadOnSearch: false
            })
            .when('/sign-in', {
              templateUrl: lqmobileConfigs.httpBase + '/content/lq/lq-mobile-app-wrapper2/' + lqmobileConfigs.currentLocale + '/la-quinta-returns/lq-returns-sign-in.content.html' + routing,
              // templateUrl: './test/lq-returns-sign-in.content.html',
              // controller: 'signinPartialController',
              reloadOnSearch: false
            })
            .when('/hotel-search', {
              templateUrl: lqmobileConfigs.httpBase + '/content/lq/lq-mobile-app-wrapper2/' + lqmobileConfigs.currentLocale + '/findandbook/hotel-search.content.html' + routing,
              // templateUrl: './test/hotel-search.content.html',
              controller: 'hotelSearchPartialController',
              reloadOnSearch: false
            })
            .when('/hotel-details/:id', {
              templateUrl: function (params) {
                return lqmobileConfigs.httpBase + '/content/lq/lq-mobile-app-wrapper2/' + lqmobileConfigs.currentLocale + '/findandbook/hotel-details.content.' + params.id + '.html' + routing;
              },
              // templateUrl: './test/hotel-details.content.0630.html',
              controller: 'hotelInformationPartialController',
              reloadOnSearch: false
            })
            .when('/booking-recap', {
              templateUrl: lqmobileConfigs.httpBase + '/content/lq/lq-mobile-app-wrapper2/' + lqmobileConfigs.currentLocale + '/findandbook/booking-recap.content.html' + routing,
              // templateUrl: './stored/booking-recap.content.html',
              controller: 'bookingPartialController',
              reloadOnSearch: false
            })
            .when('/booking-guest-info', {
              templateUrl: lqmobileConfigs.httpBase + '/content/lq/lq-mobile-app-wrapper2/' + lqmobileConfigs.currentLocale + '/findandbook/booking-guest-info.content.html' + routing,
              // templateUrl: './test/booking-guest-info.content.html',
              controller: 'bookingPartialController',
              reloadOnSearch: false
            })
            .when('/booking-guarantee-info', {
              templateUrl: lqmobileConfigs.httpBase + '/content/lq/lq-mobile-app-wrapper2/' + lqmobileConfigs.currentLocale + '/findandbook/booking-guarantee-info.content.html' + routing,
              // templateUrl: './test/booking-guarantee-info.content.html',
              controller: 'bookingPartialController',
              reloadOnSearch: false
            })
            .when('/instant-hold', {
              templateUrl: lqmobileConfigs.httpBase + '/content/lq/lq-mobile-app-wrapper2/' + lqmobileConfigs.currentLocale + '/findandbook/instant-hold.content.html' + routing,
              controller: 'bookingPartialController',
              reloadOnSearch: false
            })
            .when('/booking-confirmation', {
              templateUrl: lqmobileConfigs.httpBase + '/content/lq/lq-mobile-app-wrapper2/' + lqmobileConfigs.currentLocale + '/findandbook/booking-confirmation.content.html' + routing,
              // templateUrl: './test/booking-confirmation.content.html',
              controller: 'bookingPartialController',
              reloadOnSearch: false
            })
            .when('/join-lq-returns', {
              templateUrl: lqmobileConfigs.httpBase + '/content/lq/lq-mobile-app-wrapper2/' + lqmobileConfigs.currentLocale + '/la-quinta-returns/join-lq-returns.content.html' + routing,
              // templateUrl: './test/join-lq-returns.content.html',
              controller: 'genericPartialController',
              reloadOnSearch: false
            })
            .when('/account-summary', {
              templateUrl: lqmobileConfigs.httpBase + '/content/lq/lq-mobile-app-wrapper2/' + lqmobileConfigs.currentLocale + '/la-quinta-returns/account-summary.content.html' + routing,
              // templateUrl: './test/account-summary.html',
              controller: 'genericPartialController',
              reloadOnSearch: false
            })
            .when('/account-activity', {
              templateUrl: lqmobileConfigs.httpBase + '/content/lq/lq-mobile-app-wrapper2/' + lqmobileConfigs.currentLocale + '/la-quinta-returns/account-activity.content.html' + routing,
              controller: 'genericPartialController',
              reloadOnSearch: false
            })
            .when('/my-reservations', {
              templateUrl: lqmobileConfigs.httpBase + '/content/lq/lq-mobile-app-wrapper2/' + lqmobileConfigs.currentLocale + '/my-reservations.content.html' + routing,
              controller: 'genericPartialController',
              reloadOnSearch: false
            })
            .when('/reservation-details', {
              templateUrl: lqmobileConfigs.httpBase + '/content/lq/lq-mobile-app-wrapper2/' + lqmobileConfigs.currentLocale + '/my-reservations/reservation-details.content.html' + routing,
              controller: 'genericPartialController',
              reloadOnSearch: false
            })
            .when('/edit-profile', {
              templateUrl: lqmobileConfigs.httpBase + '/content/lq/lq-mobile-app-wrapper2/' + lqmobileConfigs.currentLocale + '/la-quinta-returns/edit-profile.content.html' + routing,
              // templateUrl: './test/edit-profile.content.html',
              controller: 'genericPartialController',
              reloadOnSearch: false
            })
            .when('/favorite-hotels', {
              templateUrl: lqmobileConfigs.httpBase + '/content/lq/lq-mobile-app-wrapper2/' + lqmobileConfigs.currentLocale + '/favorite-hotels.content.html' + routing,
              // templateUrl: './test/favorite-hotels.content.html',
              controller: 'genericPartialController',
              reloadOnSearch: false
            })
            .when('/mobile-checkout', {
              templateUrl: lqmobileConfigs.httpBase + '/content/lq/lq-mobile-app-wrapper2/' + lqmobileConfigs.currentLocale + '/mobile-checkout/mobile-checkout.content.html' + routing,
              reloadOnSearch: false
            })
            .when('/checkout-unavailable', {
              templateUrl: lqmobileConfigs.httpBase + '/content/lq/lq-mobile-app-wrapper2/' + lqmobileConfigs.currentLocale + '/mobile-checkout/checkout-unavailable.content.html' + routing,
              controller: 'genericPartialController',
              reloadOnSearch: false
            })
            .when('/checkout-confirmation', {
              templateUrl: lqmobileConfigs.httpBase + '/content/lq/lq-mobile-app-wrapper2/' + lqmobileConfigs.currentLocale + '/mobile-checkout/checkout-confirmation.content.html' + routing,
              controller: 'genericPartialController',
              reloadOnSearch: false
            })
            .when('/mobile-check-in', {
              templateUrl: lqmobileConfigs.httpBase + '/content/lq/lq-mobile-app-wrapper2/' + lqmobileConfigs.currentLocale + '/mobile-check-in/mobile-check-in.content.html' + routing,
              // templateUrl: './test/mobile-check-in.content.html',
              reloadOnSearch: false
            })
            .when('/mobile-check-in-result', {
              templateUrl: lqmobileConfigs.httpBase + '/content/lq/lq-mobile-app-wrapper2/' + lqmobileConfigs.currentLocale + '/mobile-check-in/mobile-check-in-result.content.html' + routing,
              // templateUrl: './test/mobile-check-in-result.content.html',
              reloadOnSearch: false
            })
            .when('/free-night/room-search/:id', {
              templateUrl: function (params) {
                    // return './test/free-night-details.html';
                return lqmobileConfigs.httpBase + '/content/lq/lq-mobile-app-wrapper2/' + lqmobileConfigs.currentLocale + '/instant-free-night/free-night-details.content.' + params.id + '.html' + routing;
              },
              controller: 'freeNightSelectionController'
            })
            .when('/free-night/confirmation', {
              templateUrl: lqmobileConfigs.httpBase + '/content/lq/lq-mobile-app-wrapper2/' + lqmobileConfigs.currentLocale + '/instant-free-night/free-night-recap.content.html',
                // templateUrl: './test/free-night-confirmation.html',
              controller: 'freeNightConfirmationController'
            })
            .when('/free-night/info', {
              templateUrl: lqmobileConfigs.httpBase + '/content/lq/lq-mobile-app-wrapper2/' + lqmobileConfigs.currentLocale + '/instant-free-night/free-night-info.content.html',
              // templateUrl: './test/free-night-info.html',
              controller: 'genericPartialController'
            })
            .when('/custom-page', {
              templateUrl: lqmobileConfigs.httpBase + '/content/lq/lq-mobile-app-wrapper2/' + lqmobileConfigs.currentLocale + '/custom-page.content.html',
              // templateUrl: './test/custom-page.html',
              controller: 'genericPartialController'
            })
            .when('/returns', {
              templateUrl: lqmobileConfigs.httpBase + '/content/lq/lq-mobile-app-wrapper2/' + lqmobileConfigs.currentLocale + '/la-quinta-returns/lq-returns-sign-in.content.html' + routing,
              // templateUrl: './stored/lq-returns-sign-in.content.html',
              controller: 'genericPartialController',
              reloadOnSearch: false,
              resolve: {
                app: function (returnsUserProfileModel, $q, $location) {
                  var defer = $q.defer();
                  if (returnsUserProfileModel.isLoggedIn()) {
                    $location.path('/account-summary');
                  }
                  defer.resolve();
                  return defer.promise;
                }
              }
            })
            .when('/change-password', {
              templateUrl: lqmobileConfigs.httpBase + '/content/lq/lq-mobile-app-wrapper2/' + lqmobileConfigs.currentLocale + '/la-quinta-returns/change-password.content.html' + routing,
              controller: 'genericPartialController',
              reloadOnSearch: false
            })
            .when('/static', {
            })
            .otherwise({
              redirectTo: defaultTemplate
            });
  }]);

lqMobileModule.constant('paymentTypes', {
  CREDITCARD: 'creditcard',
  DIRECTBILL: 'directbill',
  INSTANTHOLD: 'instanthold'
});

lqMobileModule.config(function ($httpProvider) {
  'use strict';

  $httpProvider.defaults.useXDomain = true;
  $httpProvider.defaults.withCredentials = true;
  $httpProvider.defaults.headers.common['Content-Type'] = 'application/json';
  $httpProvider.defaults.headers.common.session = window.sessionStorage.getItem('global.sessionId');
  delete $httpProvider.defaults.headers.common['X-Requested-With'];
});


lqMobileModule.config(['$compileProvider', function ($compileProvider) {
  'use strict';

  $compileProvider.aHrefSanitizationWhitelist(/^\s*(https?|ftp|mailto|geo|maps|chrome-extension|file|tel):/);
  $compileProvider.debugInfoEnabled(false);
}]);

lqMobileModule.run(['$rootScope', '$modalStack',
  function ($rootScope, $modalStack) {
    'use strict';

    // iOS scroll on inputs fix
    $('body').on('touchstart', function () {
      $('input').css('pointer-events', 'auto');
    });
    $('body').on('touchmove', function () {
      $('input').css('pointer-events', 'none');
    });
    $('body').on('touchend', function () {
      setTimeout(function () {
        $('input').css('pointer-events', 'none');
      }, 500); // 500 to get past click delay
    });

    $rootScope.$on('$locationChangeStart', function (event) {
      var top = $modalStack.getTop();
      if (top) {
        $modalStack.dismiss(top.key);
        event.preventDefault();
      }
    });

    $rootScope.$on('$viewContentLoaded', function () {
      // iOS scroll on inputs fix
      $('input').css('pointer-events', 'none');
    });
  }]);

