/* jslint nomen: true */
/* global lqMobileModule, satellite*/
/* jshint maxstatements: 50 */
lqMobileModule.factory('satelliteTrackingModelService', [
  function () {
    'use strict';

    var satelliteTrackingModelService = {};

    function satelliteNotEmpty() {
      return (typeof satellite !== 'undefined');
    }

    satelliteTrackingModelService.setAppVersion = function (appVersion) {
      if (satelliteNotEmpty()) {
        satellite.setVar('appVersion', appVersion);
      }
    };

    satelliteTrackingModelService.changePasswordLoaded = function () {
      if (satelliteNotEmpty()) {
        satellite.track('changePasswordLoaded');
      }
    };
    satelliteTrackingModelService.changePasswordModalLoaded = function () {
      if (satelliteNotEmpty()) {
        satellite.track('changePasswordModalLoaded');
      }
    };

    satelliteTrackingModelService.setLoginStatus = function (loginStatus) {
      if (satelliteNotEmpty()) {
        if (typeof loginStatus === 'undefined') {
          loginStatus = false;
        }
        satellite.setVar('loginStatus', loginStatus);
      }
    };

    satelliteTrackingModelService.setMemberID = function (memberID) {
      if (satelliteNotEmpty()) {
        if (typeof memberID === 'undefined') {
          memberID = '';
        }
        satellite.setVar('memberID', memberID);
      }
    };

    satelliteTrackingModelService.setMemberTier = function (memberTier) {
      if (satelliteNotEmpty()) {
        if (typeof memberTier === 'undefined') {
          memberTier = '';
        }
        satellite.setVar('memberTier', memberTier);
      }
    };

    satelliteTrackingModelService.setLanguage = function (language) {
      if (satelliteNotEmpty()) {
        if (typeof language === 'undefined') {
          language = 'en';
        }
        satellite.setVar('language', language);
      }
    };

    // app is always english:
    satelliteTrackingModelService.setLanguage('en');

    satelliteTrackingModelService.homeSignInButtonClicked = function () {
      if (satelliteNotEmpty()) {
        satellite.track('homeSignInButtonClicked');
      }
    };

    satelliteTrackingModelService.globalMenuClosed = function () {
      if (satelliteNotEmpty()) {
        satellite.track('globalMenuClosed');
      }
    };

    satelliteTrackingModelService.globalMenuOpened = function () {
      if (satelliteNotEmpty()) {
        satellite.track('globalMenuOpened');
      }
    };

    satelliteTrackingModelService.searchByCurrentLocationIcon = function () {
      if (satelliteNotEmpty()) {
        satellite.track('searchByCurrentLocationIcon');
      }
    };

    satelliteTrackingModelService.searchByCurrentLocationLink = function () {
      if (satelliteNotEmpty()) {
        satellite.track('searchByCurrentLocationLink');
      }
    };

    satelliteTrackingModelService.rateTypeChange = function (rateSelected) {
      if (satelliteNotEmpty()) {
        if (typeof rateSelected === 'undefined' || rateSelected === null || rateSelected === '') {
        // default "best Available Rate"
          rateSelected = 'RAC';
        }
        satellite.setVar('rateTypeChange_selectedRate', rateSelected);
        satellite.track('rateTypeChange');
      }
    };

    satelliteTrackingModelService.noOfAdultsChange = function () {
      if (satelliteNotEmpty()) {
        satellite.track('noOfAdultsChange');
      }
    };

    satelliteTrackingModelService.searchRadiusChange = function () {
      if (satelliteNotEmpty()) {
        satellite.track('searchRadiusChange');
      }
    };

    satelliteTrackingModelService.calendarIconClick = function () {
      if (satelliteNotEmpty()) {
        satellite.track('calendarIconClick');
      }
    };

    satelliteTrackingModelService.globalMenuLinkSelected = function (linkLabel) {
      if (satelliteNotEmpty()) {
        satellite.setVar('globalMenuLinkSelected_selectedMenuLinkLabel', linkLabel);
        satellite.track('globalMenuLinkSelected');
      }
    };

    satelliteTrackingModelService.tripAdvisorRatingSelected = function () {
      if (satelliteNotEmpty()) {
        satellite.track('tripAdvisorRatingSelected');
      }
    };

    satelliteTrackingModelService.roomDetailsLinkSelected = function () {
      if (satelliteNotEmpty()) {
        satellite.track('roomDetailsLinkSelected');
      }
    };

    satelliteTrackingModelService.hotelAddressSelected = function () {
      if (satelliteNotEmpty()) {
        satellite.track('hotelAddressSelected');
      }
    };

    satelliteTrackingModelService.logoutLinkSelected = function () {
      if (satelliteNotEmpty()) {
        satellite.track('logoutLinkSelected');
      }
    };

    satelliteTrackingModelService.rememberMeOptionSelected = function () {
      if (satelliteNotEmpty()) {
        satellite.track('rememberMeOptionSelected');
      }
    };

    satelliteTrackingModelService.rememberMeOptionDeselected = function () {
      if (satelliteNotEmpty()) {
        satellite.track('rememberMeOptionDeselected');
      }
    };

    satelliteTrackingModelService.signInActionTaken = function () {
      if (satelliteNotEmpty()) {
        satellite.track('signInActionTaken');
      }
    };

    satelliteTrackingModelService.forgotPwdLinkSelected = function () {
      if (satelliteNotEmpty()) {
        satellite.track('forgotPwdLinkSelected');
      }
    };

    satelliteTrackingModelService.joinLQButtonSelected = function () {
      if (satelliteNotEmpty()) {
        satellite.track('joinLQButtonSelected');
      }
    };

    satelliteTrackingModelService.additionalFeaturesLinkSelected = function (linkLabel) {
      if (satelliteNotEmpty()) {
        satellite.setVar('additionalFeaturesLinkSelected_selectedFeatureLinkLabel', linkLabel);
        satellite.track('additionalFeaturesLinkSelected');
      }
    };

    satelliteTrackingModelService.hotelPhoneLinkSelected = function (phone) {
      if (satelliteNotEmpty()) {
        satellite.setVar('hotelPhoneLinkSelected_phoneDialed', phone);
        satellite.track('hotelPhoneLinkSelected');
      }
    };

    satelliteTrackingModelService.editSearchLinkSelected = function () {
      if (satelliteNotEmpty()) {
        satellite.track('editSearchLinkSelected');
      }
    };

    satelliteTrackingModelService.continueAsGuestOptionSelected = function () {
      if (satelliteNotEmpty()) {
        satellite.track('continueAsGuestOptionSelected');
      }
    };

    satelliteTrackingModelService.editMyReservationLinkSelected = function () {
      if (satelliteNotEmpty()) {
        satellite.track('editMyReservationLinkSelected');
      }
    };

    satelliteTrackingModelService.readyForYouOptionSelected = function () {
      if (satelliteNotEmpty()) {
        satellite.track('readyForYouOptionSelected');
      }
    };

    satelliteTrackingModelService.creditCardOptionSelected = function (hotelId) {
      if (satelliteNotEmpty()) {
        satellite.setVar('creditCardOptionSelected_hotelId', hotelId);
        satellite.track('creditCardOptionSelected');
      }
    };

    satelliteTrackingModelService.directBillOptionSelected = function (hotelId) {
      if (satelliteNotEmpty()) {
        satellite.setVar('directBillOptionSelected_hotelId', hotelId);
        satellite.track('directBillOptionSelected');
      }
    };

    satelliteTrackingModelService.useThisInfoToJoinLQSelected = function () {
      if (satelliteNotEmpty()) {
        satellite.track('useThisInfoToJoinLQSelected');
      }
    };

    satelliteTrackingModelService.hotelSearchCompleted = function (
      hotelCounter, error, numberOfNights, hotelSearchCount,
      checkinDate, checkoutDate, numberOfAdults, numberOfChildren,
      numberOfGuests, daysToArrival, promoCode, rateType, destinationPlace,
      searchType
  ) {
      if (satelliteNotEmpty()) {
        satellite.setVar('hotelSearchPageLoaded_numberOfHotelsSearched', hotelCounter);
        if (!error) {
        // nope:
        // satellite.setVar('hotelSearchPageLoaded_hotelID',hotelID);
          satellite.setVar('hotelSearchPageLoaded_numberOfNights', numberOfNights);
          satellite.setVar('hotelSearchPageLoaded_hotelSearchCount', hotelSearchCount);
          satellite.setVar('hotelSearchPageLoaded_checkinDate', checkinDate);
          satellite.setVar('hotelSearchPageLoaded_checkoutDate', checkoutDate);
          satellite.setVar('hotelSearchPageLoaded_numberOfAdults', numberOfAdults);
          satellite.setVar('hotelSearchPageLoaded_numberOfChildren', numberOfChildren);
          satellite.setVar('hotelSearchPageLoaded_numberOfGuests', numberOfGuests);
          satellite.setVar('hotelSearchPageLoaded_daysToArrival', daysToArrival);
          satellite.setVar('hotelSearchPageLoaded_promoCode', promoCode);
          if (typeof rateType === 'undefined' || rateType === null || rateType === '') {
          // default "best Available Rate"
            rateType = 'RAC';
          }
          satellite.setVar('hotelSearchPageLoaded_rateType', rateType);
          if (typeof destinationPlace === 'undefined' || destinationPlace === null) {
            destinationPlace = 'current location';
          }
          satellite.setVar('hotelSearchPageLoaded_destinationPlace', destinationPlace);
          satellite.setVar('hotelSearchPageLoaded_searchType', searchType);
          satellite.track('hotelSearchPageLoaded');
        } else {
          satellite.track('hotelSearchPageLoadedWithError');
        }
      }
    };

    satelliteTrackingModelService.hotelRoomCompleted = function (error, hotelName, hotelId) {
      if (satelliteNotEmpty()) {
        if (!error) {
          satelliteTrackingModelService.hotelDetailsPageLoaded(hotelName, hotelId);
        } else {
          satelliteTrackingModelService.hotelDetailsPageLoadedWithError(hotelName, hotelId);
        }
      }
    };

    satelliteTrackingModelService.hotelDetailsPageLoaded = function (hotelName, hotelId) {
      if (satelliteNotEmpty()) {
        satellite.setVar('hotelDetailsPageLoaded_hotelName', hotelName);
        satellite.setVar('hotelDetailsPageLoaded_hotelId', hotelId);

        satellite.track('hotelDetailsPageLoaded');
      }
    };

    satelliteTrackingModelService.hotelDetailsPageLoadedWithError = function (hotelName, hotelId) {
      if (satelliteNotEmpty()) {
        satellite.setVar('hotelDetailsPageLoadedWithError_hotelName', hotelName);
        satellite.setVar('hotelDetailsPageLoadedWithError_hotelId', hotelId);

        satellite.track('hotelDetailsPageLoadedWithError');
      }
    };

    satelliteTrackingModelService.readMoreFeaturesButtonClicked = function () {
      if (satelliteNotEmpty()) {
        satellite.track('readMoreFeaturesButtonClicked');
      }
    };

    satelliteTrackingModelService.hotelSavedInFavorites = function (hotelId) {
      if (satelliteNotEmpty()) {
        satellite.setVar('favoriteHotelAdded', hotelId);
        satellite.track('hotelSavedInFavorites');
      }
    };

    satelliteTrackingModelService.hotelRemovedFromFavorites = function (hotelId) {
      if (satelliteNotEmpty()) {
        satellite.setVar('favoriteHotelRemoved', hotelId);
        satellite.track('hotelRemovedFromFavorites');
      }
    };

    satelliteTrackingModelService.findHotelsButtonClicked = function () {
      if (satelliteNotEmpty()) {
        satellite.track('findHotelsButtonClicked');
      }
    };

    satelliteTrackingModelService.viewBookingDetailsButtonSelected = function () {
      if (satelliteNotEmpty()) {
        satellite.track('viewBookingDetailsButtonSelected');
      }
    };

    satelliteTrackingModelService.bookThisHotelLinkSelected = function () {
      if (satelliteNotEmpty()) {
        satellite.track('bookThisHotelLinkSelected');
      }
    };

    satelliteTrackingModelService.editReservationButtonSelected = function () {
      if (satelliteNotEmpty()) {
        satellite.track('editReservationButtonSelected');
      }
    };

    satelliteTrackingModelService.cancelReservationButtonSelected = function () {
      if (satelliteNotEmpty()) {
        satellite.track('cancelReservationButtonSelected');
      }
    };


    satelliteTrackingModelService.homeLoaded = function () {
      if (satelliteNotEmpty()) {
        satellite.track('homeLoaded');
      }
    };

    satelliteTrackingModelService.bookingRecapLoaded = function (hotelId, promoCode) {
      if (satelliteNotEmpty()) {
        satellite.setVar('bookingRecapLoaded_hotelId', hotelId);
        satellite.setVar('bookingRecapLoaded_promoCode', promoCode);
        satellite.track('bookingRecapLoaded');
      }
    };

    satelliteTrackingModelService.bookingInfoModalLoaded = function (hotelId) {
      if (satelliteNotEmpty()) {
        satellite.setVar('bookingInfoModelLoaded_hotelId', hotelId);
        satellite.track('bookingInfoModalLoaded');
      }
    };

    satelliteTrackingModelService.bookingGuestInfoLoaded = function () {
      if (satelliteNotEmpty()) {
        satellite.track('bookingGuestInfoLoaded');
      }
    };

    satelliteTrackingModelService.bookingGuaranteeInfoLoaded = function (hotelId) {
      if (satelliteNotEmpty()) {
        satellite.setVar('bookingGuaranteeInfoLoaded_hotelId', hotelId);
        satellite.track('bookingGuaranteeInfoLoaded');
      }
    };

    satelliteTrackingModelService.lqInstantHoldInfoLoaded = function (hotelID) {
      if (satelliteNotEmpty()) {
        satellite.setVar('lqInstantHoldInfoLoaded_hotelID', hotelID);
        satellite.track('lqInstantHoldInfoLoaded');
      }
    };

    satelliteTrackingModelService.lqInstantHoldConfirmationLoaded = function (
      numberOfNights,
      totalRate,
      totalTaxes,
      currencyCode,
      hotelId,
      checkinDate,
      checkoutDate,
      numberOfAdults,
      daysToArrival,
      roomTypeName,
      guestPostalCode,
      promoCode,
      roomBookingType,
      confirmationNum,
      reservationRevenue
  ) {
      if (satelliteNotEmpty()) {
        satellite.setVar('lqInstantHoldConfirmationLoaded_numberOfNights', numberOfNights);
        satellite.setVar('lqInstantHoldConfirmationLoaded_totalRate', totalRate);
        satellite.setVar('lqInstantHoldConfirmationLoaded_totalTaxes', totalTaxes);
        satellite.setVar('lqInstantHoldConfirmationLoaded_currencyCode', currencyCode);
        satellite.setVar('lqInstantHoldConfirmationLoaded_hotelId', hotelId);
        satellite.setVar('lqInstantHoldConfirmationLoaded_checkinDate', checkinDate);
        satellite.setVar('lqInstantHoldConfirmationLoaded_checkoutDate', checkoutDate);
        satellite.setVar('lqInstantHoldConfirmationLoaded_numberOfAdults', numberOfAdults);
        satellite.setVar('lqInstantHoldConfirmationLoaded_daysToArrival', daysToArrival);
        satellite.setVar('lqInstantHoldConfirmationLoaded_roomTypeName', roomTypeName);
        satellite.setVar('lqInstantHoldConfirmationLoaded_guestPostalCode', guestPostalCode);
        satellite.setVar('lqInstantHoldConfirmationLoaded_promoCode', promoCode);
        satellite.setVar('lqInstantHoldConfirmationLoaded_roomBookingType', roomBookingType);
        satellite.setVar('lqInstantHoldConfirmationLoaded_confirmationNum', confirmationNum);
        satellite.setVar('lqInstantHoldConfirmationLoaded_reservationRevenue', reservationRevenue);

        satellite.track('lqInstantHoldConfirmationLoaded');
      }
    };

    satelliteTrackingModelService.standardConfirmationLoaded = function (
      numberOfNights,
      totalRate,
      totalTaxes,
      currencyCode,
      checkinDate,
      checkoutDate,
      numberOfAdults,
      daysToArrival,
      roomTypeName,
      guestPostalCode,
      promoCode,
      roomBookingType,
      confirmationNum,
      isFreeNight,
      reservationRevenue) {
      if (satelliteNotEmpty()) {
        satellite.setVar('standardConfirmationLoaded_numberOfNights', numberOfNights);
        satellite.setVar('standardConfirmationLoaded_totalRate', totalRate);
        satellite.setVar('standardConfirmationLoaded_totalTaxes', totalTaxes);
        satellite.setVar('standardConfirmationLoaded_currencyCode', currencyCode);
        satellite.setVar('standardConfirmationLoaded_checkinDate', checkinDate);
        satellite.setVar('standardConfirmationLoaded_checkoutDate', checkoutDate);
        satellite.setVar('standardConfirmationLoaded_numberOfAdults', numberOfAdults);
        satellite.setVar('standardConfirmationLoaded_daysToArrival', daysToArrival);
        satellite.setVar('standardConfirmationLoaded_roomTypeName', roomTypeName);
        satellite.setVar('standardConfirmationLoaded_guestPostalCode', guestPostalCode);
        satellite.setVar('standardConfirmationLoaded_promoCode', promoCode);
        satellite.setVar('standardConfirmationLoaded_roomBookingType', roomBookingType);
        satellite.setVar('standardConfirmationLoaded_isFreeNight', isFreeNight);
        satellite.setVar('standardConfirmationLoaded_roomTypeName', roomTypeName);
        satellite.setVar('standardConfirmationLoaded_guestPostalCode', guestPostalCode);
        satellite.setVar('standardConfirmationLoaded_confirmationNum', confirmationNum);
        satellite.setVar('standardConfirmationLoaded_reservationRevenue', reservationRevenue);
        satellite.track('standardConfirmationLoaded');
      }
    };

    satelliteTrackingModelService.returnsIndexLoaded = function () {
      if (satelliteNotEmpty()) {
        satellite.track('returnsIndexLoaded');
      }
    };

    satelliteTrackingModelService.returnsAccountSummaryLoaded = function () {
      if (satelliteNotEmpty()) {
        satellite.track('returnsAccountSummaryLoaded');
      }
    };

    satelliteTrackingModelService.returnsJoinLoaded = function () {
      if (satelliteNotEmpty()) {
        satellite.track('returnsJoinLoaded');
      }
    };

    satelliteTrackingModelService.returnsEditProfileLoaded = function () {
      if (satelliteNotEmpty()) {
        satellite.track('returnsEditProfileLoaded');
      }
    };

    satelliteTrackingModelService.myReservationsLoaded = function () {
      if (satelliteNotEmpty()) {
        satellite.track('myReservationsLoaded');
      }
    };

    satelliteTrackingModelService.editReservationLoaded = function (
      hotelId, numberOfNights, checkinDate, checkoutDate, numberOfAdults, daysToArrival,
      promoCode, rateType
    ) {
      if (satelliteNotEmpty()) {
        satellite.setVar('editReservationLoaded_hotelId', hotelId);
        satellite.setVar('editReservationLoaded_numberOfNights', numberOfNights);
        satellite.setVar('editReservationLoaded_checkinDate', checkinDate);
        satellite.setVar('editReservationLoaded_checkoutDate', checkoutDate);
        satellite.setVar('editReservationLoaded_numberOfAdults', numberOfAdults);
        satellite.setVar('editReservationLoaded_daysToArrival', daysToArrival);
        satellite.setVar('editReservationLoaded_promoCode', promoCode);
        if (typeof rateType === 'undefined' || rateType === null || rateType === '') {
        // default "best Available Rate"
          rateType = 'RAC';
        }
        satellite.setVar('editReservationLoaded_rateType', rateType);

        satellite.track('editReservationLoaded');
      }
    };

    satelliteTrackingModelService.myFavoriteHotelsLoaded = function () {
      if (satelliteNotEmpty()) {
        satellite.track('myFavoriteHotelsLoaded');
      }
    };

    satelliteTrackingModelService.yelpCategorySelected = function (yelpCategory) {
      if (satelliteNotEmpty()) {
        satellite.setVar('yelpCategory', yelpCategory);
        satellite.track('yelpCategorySelected');
      }
    };

    satelliteTrackingModelService.yelpAttractionSelected = function (yelpAttraction) {
      if (satelliteNotEmpty()) {
        satellite.setVar('yelpAttraction', yelpAttraction);
        satellite.track('yelpAttractionSelected');
      }
    };

    /* params:
      - pageWhereEnvoked: string -
          page name (i.e fingerprintLoginPrompt, signInPage, editProfilePage)
      - enabled: boolean - true if enabled, false if disabled
      - memberID: string - members return id
    */
    satelliteTrackingModelService.fingerprintLoginStateToggled = function (
      pageWhereEnvoked, enabled, memberID
    ) {
      if (satelliteNotEmpty()) {
        satellite.setVar('fingerprintLoginStateToggled_envokedScreen', pageWhereEnvoked);
        satellite.setVar('fingerprintLoginStateToggled_enabledState', !!enabled);
        satellite.setVar('fingerprintLoginStateToggled_memberID', memberID);
        satellite.track('fingerprintLoginStateToggled');
      }
    };

    satelliteTrackingModelService.mobileCheckoutBannerShown = function (
      isEligible, confirmationNumber
    ) {
      if (satelliteNotEmpty()) {
        satellite.setVar('mobileCheckoutBannerShown_isEligible', !!isEligible);
        satellite.setVar('mobileCheckoutBannerShown_confirmationNumber', confirmationNumber);
        satellite.track('mobileCheckoutBannerShown');
      }
    };

    satelliteTrackingModelService.mobileCheckoutBannerClicked = function () {
      if (satelliteNotEmpty()) {
        satellite.track('mobileCheckoutBannerClicked');
      }
    };

    satelliteTrackingModelService.mobileCheckoutAttempted = function () {
      if (satelliteNotEmpty()) {
        satellite.track('mobileCheckoutAttempted');
      }
    };

    satelliteTrackingModelService.mobileCheckoutCompleted = function () {
      if (satelliteNotEmpty()) {
        satellite.track('mobileCheckoutCompleted');
      }
    };

    satelliteTrackingModelService.mobileCheckoutUnsuccessful = function () {
      if (satelliteNotEmpty()) {
        satellite.track('mobileCheckoutUnsuccessful');
      }
    };

    satelliteTrackingModelService.pushNotificationTouched = function (
      pushNotificationType
    ) {
      if (satelliteNotEmpty()) {
        satellite.setVar('pushNotificationTouched_notificationType', pushNotificationType);
        satellite.track('pushNotificationTouched');
      }
    };

    satelliteTrackingModelService.pushNotificationCheckIn = function () {
      if (satelliteNotEmpty()) {
        satellite.track('pushNotificationCheckIn');
      }
    };

    satelliteTrackingModelService.pushNotificationCheckOut = function () {
      if (satelliteNotEmpty()) {
        satellite.track('pushNotificationCheckOut');
      }
    };

    satelliteTrackingModelService.persistentStorageError = function () {
      if (satelliteNotEmpty()) {
        satellite.track('persistentStorageError');
      }
    };

    satelliteTrackingModelService.freeNightBannerShown = function (propID) {
      if (satelliteNotEmpty()) {
        satellite.setVar('freeNightBannerShown_propertyId', propID); // <- string
        satellite.track('freeNightBannerShown');
      }
    };

    satelliteTrackingModelService.freeNightBannerClicked = function (propID) {
      if (satelliteNotEmpty()) {
        satellite.setVar('freeNightBannerClicked_propertyId', propID); // <- string
        satellite.track('freeNightBannerClicked');
      }
    };

    satelliteTrackingModelService.locationPermissionGranted = function () {
      if (satelliteNotEmpty()) {
        satellite.track('locationPermissionGranted');
      }
    };

    satelliteTrackingModelService.locationPermissionDenied = function () {
      if (satelliteNotEmpty()) {
        satellite.track('locationPermissionDenied');
      }
    };

    satelliteTrackingModelService.mobileCheckinUnsuccessful = function () {
      if (satelliteNotEmpty()) {
        satellite.track('mobileCheckinUnsuccessful');
      }
    };

    satelliteTrackingModelService.mobileCheckinCompleted = function () {
      if (satelliteNotEmpty()) {
        satellite.track('mobileCheckinCompleted');
      }
    };

    satelliteTrackingModelService.mobileCheckInButtonClicked = function () {
      if (satelliteNotEmpty()) {
        satellite.track('mobileCheckinButtonClicked');
      }
    };

    satelliteTrackingModelService.mobileCheckInDisplayed = function () {
      if (satelliteNotEmpty()) {
        satellite.track('mobileCheckinDisplayed');
      }
    };

    satelliteTrackingModelService.mobileCheckInAlreadyDone = function () {
      if (satelliteNotEmpty()) {
        satellite.track('mobileCheckInAlreadyDone');
      }
    };

    return satelliteTrackingModelService;
  }]);
