/* global lqMobileModule, lqmobileConfigs, lqMobile, CQ*/
lqMobileModule.factory('serviceEndPoints', [

  function () {
    'use strict';

    var service = {};

    service.data = {
      checkinDate: lqMobile.Defaults.getDefaultCheckin(),
      checkoutDate: lqMobile.Defaults.getDefaultCheckout(),
      numGuests: '',
      currentHotel: null,
      currentPlace: null,
      latitude: null,
      longitude: null
    };

    service.getGoogleFiltersEndPoint = function () {
      return lqmobileConfigs.httpBase + '/etc/lq-admin/lq-filter-mappings/jcr:content/grid.1.infinity.json';
    };

    service.getHotelSummariesEndPoint = function () {
      return lqmobileConfigs.httpBase + '/bin/lq/allHotelDetailsSummary.json';
    };

    service.getHotelAvailabilityEndPoint = function () {
      return lqmobileConfigs.servicesEndpoint + lqmobileConfigs.hotelAvailability + '?apikey=' + lqmobileConfigs.apikey;
    };

    service.getHotelRoomAvailabilityEndPoint = function () {
      return lqmobileConfigs.servicesEndpoint + lqmobileConfigs.hotelRoomAvailability + '?apikey=' + lqmobileConfigs.apikey;
    };

    service.getReturnsAuthenticationEndPoint = function () {
      return lqmobileConfigs.servicesEndpoint + lqmobileConfigs.returnsAuthenticationUrl;
    };

    service.getUserProfileEndPoint = function () {
      return lqmobileConfigs.servicesEndpoint + lqmobileConfigs.userProfileUrl;
    };

    service.getCreditCardsEndPoint = function () {
      return lqmobileConfigs.servicesEndpoint + lqmobileConfigs.creditCardsUrl;
    };

    service.getCreditCardsReplaceEndPoint = function () {
      return lqmobileConfigs.servicesEndpoint + lqmobileConfigs.primaryCreditCardsUrl;
    };

    service.getBookingConfirmationEndPoint = function () {
      return lqmobileConfigs.servicesEndpoint + lqmobileConfigs.bookingConfirmationUrl + '?apikey=' + lqmobileConfigs.apikey;
    };

    service.getAccountActivityUrlEndPoint = function () {
      return lqmobileConfigs.servicesEndpoint + lqmobileConfigs.accountActivityUrl;
    };

    service.getReservationsEndPoint = function () {
      return lqmobileConfigs.servicesEndpoint + lqmobileConfigs.reservationsUrl;
    };

    service.getApiKey = function () {
      return lqmobileConfigs.apikey;
    };

    service.getChangePasswordEndPoint = function (returnsId) {
      var url = lqmobileConfigs.servicesEndpoint + lqmobileConfigs.changePasswordUrl;
      return url.replace('{id}', returnsId);
    };

    service.getDestinationsAutoCompleteEndPoint = function (startingChar) {
      return lqmobileConfigs.httpBase + '/etc/lq-admin/lq-destinations-auto-complete/jcr:content/grid/' + startingChar + '.1.infinity.json';
    };

    service.getHotelDetailsEndPoint = function (hotelId) {
      return lqmobileConfigs.httpBase + '/bin/lq/hotelDetails.' + CQ.I18n.getLocale() + '.' + hotelId + '.json';
    };

    service.getSessionIdEndPoint = function (sessionId) {
      var url = lqmobileConfigs.servicesEndpoint + lqmobileConfigs.sessionIdUrl;
      return url.replace('{sessionId}', sessionId) + '?apikey=' + lqmobileConfigs.apikey;
    };

    service.getReadyForYouEndPoint = function () {
      return lqmobileConfigs.servicesEndpoint + lqmobileConfigs.getreadyforyouUrl + '?apikey=' + lqmobileConfigs.apikey;
    };

    service.getHotelReviewsEndPoint = function (hotelId) {
      var url = lqmobileConfigs.servicesEndpoint + lqmobileConfigs.hotelReviewsUrl;
      return url.replace('{hotelId}', hotelId) + '?apikey=' + lqmobileConfigs.apikey;
    };

    service.getUserDeviceEndPoint = function () {
      return lqmobileConfigs.servicesEndpoint + lqmobileConfigs.userDeviceUrl;
    };

    service.getMobileCheckoutEligibility = function () {
      return lqmobileConfigs.servicesEndpoint + lqmobileConfigs.mobileCheckoutEligibilityUrl;
    };

    service.getMobileCheckoutAction = function (confirmationNumber) {
      var url = lqmobileConfigs.servicesEndpoint + lqmobileConfigs.mobileCheckoutActionUrl;
      return url.replace('{confirmationNumber}', confirmationNumber);
    };

    service.getFreeNightEligibilityUrl = function () {
      return lqmobileConfigs.servicesEndpoint + lqmobileConfigs.freeNightEligibilityUrl;
    };

    service.getActiveStaysEndPoint = function (returnsNumber) {
      var url = lqmobileConfigs.servicesEndpointMci + lqmobileConfigs.findActiveStays;
      return url.replace('{returnsNumber}', returnsNumber);
    };

    service.getMobileCheckinAction = function (innNumber, confirmationNumber, roomNumber) {
      var roomNumberStr = (!isNaN(parseInt(roomNumber, 10)) && roomNumber != 0) ? '/rooms/' + roomNumber : '';
      var url = lqmobileConfigs.servicesEndpointMci + lqmobileConfigs.mobileCheckinActionUrl;
      return url.replace('{innNumber}', innNumber).replace('{confirmationNumber}', confirmationNumber).replace('{roomStr}', roomNumberStr);
    };

    service.getMobileCheckinGetRooms = function (innNumber) {
      var url = lqmobileConfigs.servicesEndpointMci + lqmobileConfigs.mobileCheckinGetRooms;
      return url.replace('{innNumber}', innNumber);
    };

    service.getMobileCheckinHotelDetails = function () {
      return lqmobileConfigs.servicesEndpoint + lqmobileConfigs.mobileCheckinGetHotelDetails;
    };

    return service;
  }]);
