/* global lqMobileModule, console, angular*/
lqMobileModule.factory('sessionIdEndpointService', ['$http',
  'serviceEndPoints',
  function ($http,
    serviceEndPoints) {
    'use strict';

    var endpointService = {};

    endpointService.generateSessionIdCookie = function (sessionId) {
      var serviceURL = serviceEndPoints.getSessionIdEndPoint(sessionId);

      return $http({
        method: 'get',
        url: serviceURL
      }).then(
        function (response) {
          return response;
        },
        function (error) {
          console.error(JSON.stringify(error));
          throw error;
        }
    );
    };

    return endpointService;
  }]);
