/* global lqMobileModule, LQMobile*/
lqMobileModule.directive('ccvalidator', ['$parse',
  function () {
    'use strict';

    return {
      require: 'ngModel',
      link: function (scope, element, attrs, modelCtrl) {
        var ccTypeFunction = function (inputValue) {
          var result = false;
          var type;
          var luhn;
          var len;
          var mul;
          var prodArr;
          var sum;
          if (inputValue.indexOf('*') === -1 && inputValue.length > 0) {
          // we validate the type first
            type = LQMobile.Util.findCCType(inputValue);
            if (typeof type !== 'undefined' && type !== 'UNKNOWN') {
            // if the type is valid, we apply the luhn validation
              luhn = inputValue;
              len = luhn.length;
              mul = 0;
              prodArr = [[0, 1, 2, 3, 4, 5, 6, 7, 8, 9], [0, 2, 4, 6, 8, 1, 3, 5, 7, 9]];
              sum = 0;
              // changing operate could have side effects, disabling lint
              while (len--) {  // eslint-disable-line
                sum += prodArr[mul][parseInt(luhn.charAt(len), 10)];
                mul ^= 1;  // eslint-disable-line
                //  not sure why bitwise is used, so leaving it, and ignoring lint
              }
              result = (sum % 10 === 0 && sum > 0);
            }
          } else {
            result = true;
          }
          modelCtrl.$setValidity('creditCard', result);
          modelCtrl.$setValidity('ccvalidator', result);
          modelCtrl.$setViewValue(inputValue);
          return inputValue;
        };
        modelCtrl.$parsers.push(ccTypeFunction);
      // ccTypeFunction($parse(attrs.ngModel)(scope)); // run on initial page load
      }
    };
  }]);
