/* global lqMobileModule, console*/
lqMobileModule.directive('creditCardExpiration', ['$parse',
  function () {
    'use strict';

    return {
      require: 'ngModel',
      link: function (scope, element, attrs, modelCtrl) {
        var ccExpFunction = function (inputValue) {
          var result = false; // we validate the type first
          var ccModelVariable = attrs.ccVariable; // getting month and year values
          var selectedMonth;
          var selectedYear;

          try {
            selectedMonth = parseInt(scope.$eval(ccModelVariable + '.ccMonth'), 10);
            selectedYear = parseInt(scope.$eval(ccModelVariable + '.ccYear'), 10);

            if (typeof selectedMonth !== 'undefined' && typeof selectedYear !== 'undefined') {
              if (selectedYear > scope.minCCYear) {
                result = true;
              } else if (selectedYear === scope.minCCYear) {
                if (selectedMonth >= scope.minCCMonth) {
                  result = true;
                }
              }
            }
          } catch (e) {
            console.log('Could not validate credit card');
          }
          modelCtrl.$setValidity('creditCardExpiration', result);
          scope[attrs.formName].ccMonth.$setValidity('creditCardExpiration', result);
          scope[attrs.formName].ccYear.$setValidity('creditCardExpiration', result);

          modelCtrl.$setViewValue(inputValue);
          return inputValue;
        };
        modelCtrl.$formatters.push(ccExpFunction);
      }
    };
  }]);
