/* global lqMobileModule*/
lqMobileModule.directive('email', [function () {
  'use strict';

  return {
    restrict: 'A',
    require: 'ngModel',
    link: function (scope, element, attr, ctrl) {
      function customValidator(ngModelValue) {
        if (/^[a-z0-9!#$%&'*+/=?^_`{|}~.-]+@([a-z0-9-]+)*\.[a-zA-Z0-9-]+.[a-zA-Z0-9-]*$/i.test(ngModelValue)) {
          ctrl.$setValidity('formatValidator', true);
        } else {
          ctrl.$setValidity('formatValidator', false);
        }
        if (ngModelValue.length <= 30) {
          ctrl.$setValidity('maxLengthValidator', true);
        } else {
          ctrl.$setValidity('maxLengthValidator', false);
        }
        return ngModelValue;
      }
      ctrl.$parsers.push(customValidator);
    }
  };
}]);
