/* global lqMobileModule*/
lqMobileModule.directive('phone', [function () {
  'use strict';

  return {
    restrict: 'A',
    require: 'ngModel',
    link: function (scope, element, attr, ctrl) {
      function customValidator(ngModelValue) {
        if (/^[0-9\-().+#]+$/.test(ngModelValue)) {
          ctrl.$setValidity('charactersValidator', true);
        } else {
          ctrl.$setValidity('charactersValidator', false);
        }
        if (ngModelValue.length <= 20) {
          ctrl.$setValidity('maxLengthValidator', true);
        } else {
          ctrl.$setValidity('maxLengthValidator', false);
        }
        return ngModelValue;
      }
      ctrl.$parsers.push(customValidator);
    }
  };
}]);
