/* global lqMobileModule*/
lqMobileModule.directive('luhn', ['$parse',
  function ($parse) {
    'use strict';

    return {
      require: 'ngModel',
      link: function (scope, element, attrs, modelCtrl) {
        var luhnFunction = function (inputValue) {
          var luhn = inputValue;
          var len = luhn.length;
          var mul = 0;
          var prodArr = [[0, 1, 2, 3, 4, 5, 6, 7, 8, 9], [0, 2, 4, 6, 8, 1, 3, 5, 7, 9]];
          var sum = 0;

          if (typeof inputValue === 'undefined' || inputValue === '') {
            return false;
          }
          // changing operate could have side effects, disabling lint
          while (len--) { // eslint-disable-line
            sum += prodArr[mul][parseInt(luhn.charAt(len), 10)];
            mul ^= 1; // eslint-disable-line
          //  not sure why bitwise is used, so leaving it, and ignoring lint
          }
          return (sum % 10 === 0 && sum > 0);
        };
        modelCtrl.$parsers.push(luhnFunction);
        luhnFunction($parse(attrs.ngModel)(scope));
      }
    };
  }]);
