/* global lqMobileModule, CQ*/

/*
 * Filter used to express distances on kilometers or miles
 */
lqMobileModule.filter('distance', function ($filter) {
  'use strict';

  return function (miles, decPlaces, thouSep, decSep, countryCode) {
    var result = miles;
    var distanceLabel = CQ.I18n.getMessage('miles');
    if (countryCode === 'MX') {
      result = miles * 1.609;
      distanceLabel = CQ.I18n.getMessage('kilometers');
    }
    result = result.toString();
        // Replace the thousand and decimal separators.
        // This is a two step process to avoid overlaps between the two
    if (thouSep !== ',') {
      result = result.replace(/,/g, 'T');
    }
    if (decSep !== '.') {
      result = result.replace(/\./g, 'D');
    }
    result = result.replace(/T/g, thouSep);
    result = result.replace(/D/g, decSep);

    result = $filter('number')(result, decPlaces) + ' ' + distanceLabel;
    return result;
  };
});
