/* global lqMobileModule*/
lqMobileModule.factory('googleFilterEndpointService', ['$window', '$q', '$http', 'serviceEndPoints',
  function ($window, $q, $http, serviceEndPoints) {
    'use strict';

    var endpointService = {};

    function loadGoogleFilters() {
      var googleFiltersURL = serviceEndPoints.getGoogleFiltersEndPoint();
      $http.get(googleFiltersURL).success(function (filters) {
        var result = {};
        var filterKey;
        var keySet;
        var filter;
        var filterData;
        // changing for in loops could have side effects, disabled lint for both
        for (filterKey in filters) { // eslint-disable-line
          if (filters.hasOwnProperty(filterKey)) {
            keySet = filters[filterKey];
            for (filter in keySet) { // eslint-disable-line
              if (keySet.hasOwnProperty(filter)) {
                filterData = keySet[filter];
                if (filterData.hasOwnProperty('Origin')) {
                  result[filterData.Origin] = filterData.Destination;
                }
              }
            }
          }
        }
        endpointService.deferredGoogleFilters.resolve(result);
      });
    }

    endpointService.getGoogleFilters = function () {
      if (endpointService.deferredGoogleFilters === undefined) {
        endpointService.deferredGoogleFilters = $q.defer();
        loadGoogleFilters();
      }

      return endpointService.deferredGoogleFilters.promise;
    };

    return endpointService;
  }]);
