/* global lqMobileModule*/
lqMobileModule.factory('googleFilterModel', ['$q', 'googleFilterEndpointService',
  function ($q, googleFilterEndpointService) {
    'use strict';

    var dataModel = {
      data: {
        googleFilterPromise: null,
        googleFilters: {}
      }
    };

    dataModel.filterTerm = function (term) {
      if (typeof dataModel.data.googleFilters[term] !== 'undefined') {
        return dataModel.data.googleFilters[term];
      }
      return term;
    };

    function loadGoogleFilters() {
      var deferred = $q.defer();
      googleFilterEndpointService.getGoogleFilters().then(function (filters) {
        dataModel.data.googleFilters = filters;
        deferred.resolve();
      });
      dataModel.data.googleFilterPromise = deferred.promise;
    }

    loadGoogleFilters();

    return dataModel;
  }]);
