/* global lqMobileModule */
lqMobileModule.controller(
  'freeNightSelectionController',
  [
    '$scope',
    '$modal',
    '$rootScope',
    'routingService',
    'searchParamModelService',
    'reservationsModel',
    'hotelInformationModel',
    'bookingModelService',
    'editSearchPanelCollapseFactory',
    'hotelRoomsModel',
    'freeNightModel',
    'returnsUserProfileModel',
    'events',
    'satelliteTrackingModelService',
    function ($scope,
      $modal,
      $rootScope,
      routingService,
      searchParamModelService,
      reservationsModel,
      hotelInformationModel,
      bookingModelService,
      editSearchPanelCollapseFactory,
      hotelRoomsModel,
      freeNightModel,
      returnsUserProfileModel,
      events,
      satelliteTrackingModelService) {
      'use strict';


      $scope.searchData = searchParamModelService.data;

      $scope.doLocationSearch = function () {
      };
      $scope.doFindHotels = function () {
        if (reservationsModel.data.selectedFullReservation) {
          // return hotelRoomsModel.getAvailableRooms();
          return freeNightModel.hotelRoomRates;
        }
        return routingService.goToHotelSearch();
      };

      // collapse the edit search panel when starts.
      editSearchPanelCollapseFactory.collapsePanel();

      // if there was a selected reservation and the user selected
      // to change it but then picked a different hotel, remove the
      // selected reservation
      if (
        reservationsModel.data.selectedFullReservation &&
        reservationsModel.data.selectedFullReservation.hotelId
          !== hotelInformationModel.data.hotelDetails.hotelId
      ) {
        reservationsModel.clearModel();
      }

      // clear the confirmation number (from possible previous reservation)
      bookingModelService.resetConfirmationNumber();

      function handleRouting(isInstantHoldActive, isBookWithPointsSelected) {
        if (isBookWithPointsSelected || !isInstantHoldActive) {
          routingService.goToBookingRecap();
        } else if (isInstantHoldActive) {
          routingService.goToInstantHold();
        }
      }

      $scope.freeRooms = [];
      $scope.showLoadingModal = function () {
        return $modal.open({
          templateUrl: 'loadingModalContent.html',
          windowClass: 'loading-modal-window',
          backdrop: 'static',
          keyboard: false
        });
      };

      $scope.freeRooms = freeNightModel.getAvailableRooms();

      $scope.hotelRooms = hotelRoomsModel.data;
      $scope.searchParams = searchParamModelService.data;
      $scope.userLogged = returnsUserProfileModel.isLoggedIn();
      $scope.hotelInfo = hotelInformationModel.data.hotelDetails;

      $scope.count = 0;

      $scope.open = function (room, isInstantHoldActive) {
        var modalInstance = $modal.open({
          templateUrl: 'bookRoomModalContent.html',
          controller: 'bookRoomModalInstanceCtrl',
          windowClass: 'app-modal-window'
        });

        modalInstance.result.then(function (isBookWithPointsSelected) {
          if (isBookWithPointsSelected) {
            searchParamModelService.setSelectedRoom(
              $scope.hotelRooms.fncRooms[room.hotelRoomRate.roomType.roomCode], true
            );
          } else {
            searchParamModelService.setSelectedRoom(room, false);
          }
          handleRouting(isInstantHoldActive, isBookWithPointsSelected);
        });
      };

      $scope.openHotelDetailsModal = function (room, isInstantHoldActive) {
        var modalInstance = $modal.open({
          templateUrl: 'roomDetailsModalContent.html',
          controller: 'roomDetailsModalInstanceCtrl',
          windowClass: 'app-modal-window',
          resolve: {
            room: function () {
              return room;
            }
          }
        });

        satelliteTrackingModelService.roomDetailsLinkSelected();

        modalInstance.result.then(function (iRoom) {
          freeNightModel.selectedRoom = iRoom;
          $scope.selectRoom(iRoom, isInstantHoldActive);
        });
      };

      $scope.selectRoom = function (room) {
        freeNightModel.selectedRoom = room;
        routingService.goToFreeNightConfirmation();
      };
    }]
);
