/* global lqMobileModule, LQMobile*/
lqMobileModule.controller(
  'hotelDetailsBasicController',
  [
    '$scope',
    '$timeout',
    '$rootScope',
    'hotelInformationModel',
    function (
      $scope,
      $timeout,
      $rootScope,
      hotelInformationModel
    ) {
      'use strict';

      var timer;

      $scope.hotelInfo = hotelInformationModel.data.hotelDetails;
      $scope.hide = true;
      $scope.emptyGallery = false;
      $scope.animationsEnabled = true;

      $scope.showPhotoGallery = function () {
        $scope.hide = !$scope.hide;
      };

      if ($scope.hotelInfo.hotelMobileWebPhone === '' || (typeof $scope.hotelInfo.rating === 'undefined' || $scope.hotelInfo.rating.imageURL === '')) {
        $.get(lqmobileConfigs.servicesEndpoint + '/lqecommerce/api/ecommerce/propertymaster/hotels?id=' + $scope.hotelInfo.hotelId + '&apikey=' + lqmobileConfigs.apikey,
          function (data) {
            if ($.isArray(data) && data.length > 0) {
              var hotelDetails = data[0];
              if (hotelDetails.phoneNumbers.MOBILE_WEB && hotelDetails.phoneNumbers.MOBILE_WEB.phoneNumber
                && hotelDetails.phoneNumbers.MOBILE_WEB.phoneNumber.number && hotelDetails.phoneNumbers.MOBILE_WEB.phoneNumber.number !== '') {
                $scope.hotelInfo.hotelMobileWebPhone = hotelDetails.phoneNumbers.MOBILE_WEB.phoneNumber.number;
                if (/\d{3}-\d{3}-\d{4}/.test($scope.hotelInfo.hotelMobileWebPhone)) {
                  $scope.hotelInfo.hotelMobileWebPhone = '1-' + $scope.hotelInfo.hotelMobileWebPhone;
                }
              }
              if ((typeof $scope.hotelInfo.rating === 'undefined' || $scope.hotelInfo.rating.imageURL === '')
                && (hotelDetails.hotelReviewsSummary && hotelDetails.hotelReviewsSummary.ratingImageUrl && hotelDetails.hotelReviewsSummary.totalNumberOfReviews)) {
                $scope.hotelInfo.rating = {
                  imageURL: hotelDetails.hotelReviewsSummary.ratingImageUrl,
                  numberOfReviews: hotelDetails.hotelReviewsSummary.totalNumberOfReviews
                };
              }
            }
          }
        );
      }
    }
]);
