/* global lqMobileModule*/
lqMobileModule.controller('hotelFeaturesController', ['$scope', '$modal', '$rootScope', 'hotelInformationModel', 'events', 'satelliteTrackingModelService',
  function (
    $scope, $modal, $rootScope, hotelInformationModel, events, satelliteTrackingModelService
  ) {
    'use strict';

    $scope.hotelInfo = hotelInformationModel.data.hotelDetails;

    $scope.amenitiesIcons = [];

    $scope.topFiveAmenities = hotelInformationModel.data.hotelDetails.amenities['Amenities & Services'].slice(0, 5);

    function getAllHotelAmenities() {
      var keys = Object.keys(hotelInformationModel.data.hotelDetails.amenities);
      var i;
      var amenities = [];
      for (i = 0; i < keys.length; i += 1) {
        amenities = amenities.concat(hotelInformationModel.data.hotelDetails.amenities[keys[i]]);
      }
      return amenities;
    }

    $scope.init = function (amenitiesIcons) {
      var hotelAmenities = getAllHotelAmenities();
      var osgiAmenitiesIcons;
      var osgiAmenity;
      var i;
      var imagePath;
      var id;
      var j;

      if (hotelAmenities.length > 0) {
        amenitiesIcons = amenitiesIcons.replace('[', '');
        amenitiesIcons = amenitiesIcons.replace(']', '');
        osgiAmenitiesIcons = amenitiesIcons.split(',');
        for (i = 0; i < osgiAmenitiesIcons.length; i += 1) {
          osgiAmenity = osgiAmenitiesIcons[i].split(':');
        // If the amenity is used by default
          if (osgiAmenity.length > 2 && osgiAmenity[3] === '1') {
            $scope.amenitiesIcons.push(osgiAmenity[2]);
          } else if (osgiAmenity.length > 2) {
          // search if osgi amenities match with a hotel amenity
            imagePath = osgiAmenity[2];
            id = osgiAmenity[0].replace(' ', '');
            for (j = 0; j < hotelAmenities.length; j += 1) {
            // if osgi amenity found in hotel amenities
              if (id === hotelAmenities[j].id) {
              // add image path
                $scope.amenitiesIcons.push(imagePath);
                break;
              }
            }
          }
        }
      }
    };

    $scope.open = function () {
      satelliteTrackingModelService.readMoreFeaturesButtonClicked();
      $modal.open({
        templateUrl: 'hotelFeaturesModal.html',
        controller: 'hotelFeaturesModalController',
        windowClass: 'app-modal-window'
      });
    };

    $('div.hideSearchWhileLoading').removeClass('hideSearchWhileLoading');
  }]);

lqMobileModule.controller('hotelFeaturesModalController', ['$scope', '$modalInstance', 'hotelInformationModel', '$sce',
  function ($scope, $modalInstance, hotelInformationModel, $sce) {
    'use strict';

    $scope.amenities = hotelInformationModel.data.hotelDetails.amenities['Amenities & Services'];
    $scope.generalAmen = hotelInformationModel.data.hotelDetails.amenities['General Amenities'];
    $scope.policies = [];
    $scope.breakfast = hotelInformationModel.data.hotelDetails.amenities['Free Bright Side Breakfast:'];
    $scope.additionalBreakfast = hotelInformationModel.data.hotelDetails.amenities['Additional Breakfast Items:'];
    $scope.trustAsHtml = $sce.trustAsHtml;

  // Some policies have html content, so we are going to remove it
    function setPolicies() {
      var i;
      var policy;

      if (typeof hotelInformationModel.data.hotelDetails.amenities.Policies !== undefined) {
        for (i = 0; i < hotelInformationModel.data.hotelDetails.amenities.Policies.length; i += 1) {
          policy = hotelInformationModel.data.hotelDetails.amenities.Policies[i].description;
        // $scope.policies.push(policy.replace(/(<([^>]+)>)/ig,""));
          $scope.policies.push(policy);
        }
      }
    }

    setPolicies();

    $scope.close = function () {
      $modalInstance.dismiss('close');
    };
  }]);
