/* global lqMobileModule, LQMobile*/
lqMobileModule.controller('hotelNearbyPlacesController', ['$scope', '$modal', 'hotelNearbyPlacesModel', 'hotelInformationModel', '$rootScope', 'events', 'satelliteTrackingModelService',
  function (
    $scope,
    $modal,
    hotelNearbyPlacesModel,
    hotelInformationModel,
    $rootScope,
    events,
    satelliteTrackingModelService
  ) {
    'use strict';

    $scope.hotelInfo = hotelInformationModel.data.hotelDetails;

    function openModal() {
      $modal.open({
        templateUrl: 'hotelNearbyPlacesModal.html',
        controller: 'hotelNearbyPlacesModalController',
        windowClass: 'app-modal-window'
      });
    }

    $scope.openNearbyPlacesModal = function (category, categoryLabel) {
      hotelNearbyPlacesModel.setSelectedCategory(categoryLabel);
        // $rootScope.$broadcast(events.yelpCategorySelected, category);
      satelliteTrackingModelService.yelpCategorySelected(category);
      if (
        hotelNearbyPlacesModel.data.hotelNearbyPlaces[$scope.hotelInfo.hotelId]
          && hotelNearbyPlacesModel.data.hotelNearbyPlaces[$scope.hotelInfo.hotelId][category]
      ) {
        hotelNearbyPlacesModel.setSelectedHotelNearbyPlaces(
          hotelNearbyPlacesModel.data.hotelNearbyPlaces[$scope.hotelInfo.hotelId][category]
        );
        hotelNearbyPlacesModel.setSelectedCategory(categoryLabel);
        openModal();
      } else {
        $scope.loadingModal = $scope.showLoadingModal();
        hotelNearbyPlacesModel.loadHotelNearbyPlaces(
          $scope.hotelInfo.hotelId, $scope.hotelInfo.geoLocation.latitude,
          $scope.hotelInfo.geoLocation.longitude, category
        ).then(function () {
          $scope.loadingModal.close();
          openModal();
        });
      }
    };
  }]);

lqMobileModule.controller('hotelNearbyPlacesModalController', ['$scope', '$modalInstance', 'hotelNearbyPlacesModel', '$window', '$rootScope', 'events', 'urlService', 'satelliteTrackingModelService',
  function (
    $scope,
    $modalInstance,
    hotelNearbyPlacesModel,
    $window,
    $rootScope,
    events,
    urlService,
    satelliteTrackingModelService
  ) {
    'use strict';

    $scope.showResultsList = true;
    $scope.showLocationDetail = false;
    $scope.selectedHotelNearbyPlaces = hotelNearbyPlacesModel.data.selectedHotelNearbyPlaces;
    $scope.selectedNearbyPlace = {};
    $scope.selectedCategory = hotelNearbyPlacesModel.data.selectedCategory;

    $scope.close = function () {
      $scope.showResultsList = true;
      $scope.showLocationDetail = false;
      $modalInstance.dismiss('close');
    };

    $scope.showDetails = function (index) {
      $scope.selectedNearbyPlace = $scope.selectedHotelNearbyPlaces[index];
      satelliteTrackingModelService.yelpAttractionSelected($scope.selectedNearbyPlace.id);
      $scope.showResultsList = false;
      $scope.showLocationDetail = true;
    };

    $scope.showList = function () {
      $scope.showResultsList = true;
      $scope.showLocationDetail = false;
    };

    $scope.goToYelpPage = function (link) {
      urlService.openExternalUrl(link);
    };

    $scope.goToGoogleMaps = function () {
      var lat = $scope.selectedNearbyPlace.location.coordinate.latitude;
      var log = $scope.selectedNearbyPlace.location.coordinate.longitude;

      urlService.openExternalUrl('http://maps.google.com/maps?q=' + lat + ',' + log);
    };
  }]);
