/* global lqMobileModule*/
lqMobileModule.controller('tripadvisorReviewsModalController', ['$scope', '$modalInstance', 'hotelReviewsModel', '$window', 'urlService',
  function ($scope, $modalInstance, hotelReviewsModel, $window, urlService) {
    'use strict';

    function getViewPortHeight() {
      return Math.max(document.documentElement.clientHeight, window.innerHeight || 0);
    }

    $scope.hotelReviews = hotelReviewsModel.data.hotelReviews;
    $scope.selectedHotelReviews = hotelReviewsModel.data.selectedHotelReviews;
    $scope.reviewBodyHeightInPixels = (getViewPortHeight() - 260) + 'px';
    $scope.displayFullText = [false, false, false, false, false];
    $scope.sortReviewsBy = '-date';
    $scope.sortReviewsByLabel = CQ.I18n.getMessage('Date: Newest First');
    $scope.pointRight = true;

    $scope.status = {
      isopen: false
    };

    $scope.setOrderBy = function (orderBy, orderByLabel, pointRight) {
      $scope.sortReviewsBy = orderBy;
      $scope.sortReviewsByLabel = orderByLabel;
      $scope.pointRight = pointRight;
      $scope.status.isopen = !$scope.status.isopen;
    };

    $scope.close = function () {
      $modalInstance.dismiss();
    };

    $scope.showFullText = function (index) {
      $scope.displayFullText[index] = true;
    };

    $scope.showAbbreviated = function (index) {
      $scope.displayFullText[index] = false;
    };

    $scope.goToTripAdvisorPage = function (link) {
      urlService.openExternalUrl(link);
    };

    $scope.getFillBarWidth = function (index) {
      var arrayPosition = $scope.selectedHotelReviews.ratingByOpinions.length - index - 1;
      var totalCategoryReviews =
        $scope.selectedHotelReviews.ratingByOpinions[arrayPosition].reviewCount;
      return parseInt(
        (totalCategoryReviews * 100) / $scope.selectedHotelReviews.totalNumberOfReviews, 10
      );
    };
  }]);
