/* global lqMobileModule*/
/* jshint maxparams: 11 */
lqMobileModule.controller('hotelSearchCalendarController', ['$scope',
  '$q',
  '$timeout',
  'editSearchCollapseFactory',
  'searchParamModelService',
  '$location',
  function ($scope,
    $q,
    $timeout,
    editSearchCollapseFactory,
    searchParamModelService,
    $location) {
    'use strict';

    $scope.activeDate = '';

    $scope.hglghtCheckOut = false;

    $scope.editSearchCollapseFactory = editSearchCollapseFactory;

    $scope.alerts = [];

    $scope.$on('hglghtCheckOut', function () {
      $scope.hglghtCheckOut = true;
    });

    $scope.$on('addAlertCalendar', function (event, arg) {
      $scope.alerts = [];
      $scope.alerts.push({
        type: arg.alertType,
        msg: arg.alertMessage
      });
    });

    $scope.$on('clearAlertsCalendar', function () {
      $scope.alerts = [];
    });

    $scope.$on('showCalendar', function () {
      $scope.toggleHglght(false);
    });

    $scope.toggleHglght = function (val) {
      var hglghtDay;
      $scope.hglghtCheckOut = val;
      if (val) { // if checkout
        hglghtDay = Math.max.apply(null, $scope.selectedDates);
      } else { // if checkin
        hglghtDay = Math.min.apply(null, $scope.selectedDates);
      }
      $scope.$broadcast('higlightSelected', {
        selected: new Date(hglghtDay),
        selectedDates: $scope.selectedDates
      });
    };

    $scope.$on('updateCalendarCollection', function (event, newDates) {
      $scope.selectedDates = newDates;
    });

    $scope.init = function () {
      var td = searchParamModelService.data.checkinDate;
      var tm = searchParamModelService.data.checkoutDate;
      var tempVal;
      var maxVal;

      $scope.minDate = new Date();
      $scope.maxDate = new Date();
      $scope.maxDate.setDate($scope.maxDate.getDate() + 365);

      $scope.selectedDates = [td.setHours(0, 0, 0, 0), tm.setHours(0, 0, 0, 0)];
      tempVal = Math.min.apply(null, $scope.selectedDates);
      maxVal = Math.max.apply(null, $scope.selectedDates);

      /* Start on the next day to prevent duplicating the
          first date */
      tempVal = new Date(tempVal).setHours(24);
      while (tempVal < maxVal) {
        $scope.selectedDates.push(tempVal);
        /* Set a day ahead after pushing to prevent
            duplicating last date */
        tempVal = new Date(tempVal).setHours(24);
      }
    };

    $scope.init();


    $scope.toggleEditDatesPanel = function () {
      searchParamModelService.data.checkinDate = new Date(
        Math.min.apply(null, $scope.selectedDates)
      );
      searchParamModelService.data.checkoutDate = new Date(
        Math.max.apply(null, $scope.selectedDates)
      );

      editSearchCollapseFactory.toggleCollapsible();
      if (editSearchCollapseFactory.isDatesPanelCollapsed()) {
        $location.search('editDates', null);
      } else {
        $location.search('editDates', true);
      }
    };

    $scope.$on('$routeUpdate', function () {
      if ($location.search().editDates) {
        if (editSearchCollapseFactory.isDatesPanelCollapsed()) {
          editSearchCollapseFactory.toggleCollapsible();
        }
      } else if (!editSearchCollapseFactory.isDatesPanelCollapsed()) {
        editSearchCollapseFactory.toggleCollapsible();
      }
    });
  }]);
