/* global lqMobileModule */
lqMobileModule.controller(
  'mobileCheckinResultController',
  [
    '$scope',
    'routingService',
    'mobileCheckinResultModel',
    'returnsUserProfileModel',
    'activeStaysModel',
    function (
      $scope,
      routingService,
      mobileCheckinResultModel,
      returnsUserProfileModel,
      activeStaysModel
    ) {
      'use strict';

      /**
       * Vars
       */
      $scope.mobileCheckinResultModel = mobileCheckinResultModel;

      function init() {
        //  if user is logged in when they reach this page, update the active stay data
        if (returnsUserProfileModel.isLoggedIn()) {
          activeStaysModel.reset();
          activeStaysModel.getActiveStay(
            returnsUserProfileModel.data.userProfile.returnsNumber
          );
        }
      }

      /**
      * requestUber
      *
      * Call global uber request method
      * @param {string} address - hotel address
      */
      $scope.requestUber = function (address) {
        $scope.executeUberRequest(address);
      };

      /**
      * getDirections
      *
      * Call global get directions method
       *
       * @param {string} address - hotel address
      */
      $scope.getDirections = function (address) {
        $scope.executeGetDirections(address);
      };

      /**
      * callFrontDesk
      *
      * Call global call Hotel method
      * @param {string} phoneNumber - hotel phone number to call
      */
      $scope.callFrontDesk = function (phoneNumber) {
        $scope.executePhoneCall(phoneNumber);
      };

      init();
    }]
);
