/* global lqMobileModule */
lqMobileModule.controller(
  'mobileCheckoutConfirmationController',
  [
    '$scope',
    'routingService',
    'mobileCheckoutModel',
    'activeStaysModel',
    'urlService',
    'localStorageService',
    function (
      $scope,
      routingService,
      mobileCheckoutModel,
      activeStaysModel,
      urlService,
      localStorageService
    ) {
      /**
      * requestUber
      *
      * Call global uber request method
      */
      $scope.requestUber = function () {
        $scope.executeUberRequest();
      };

      /**
      * getDirections
      *
      * Call global get directions method
      */
      $scope.getDirections = function () {
        $scope.executeGetDirections();
      };

      /**
      * leaveReview
      *
      * Load the LQ Trip Adviser review form in external browser.
      */
      $scope.leaveReview = function () {
        var hotelNumber = mobileCheckoutModel.innNumber;

        urlService.openExternalUrl('https://www.lq.com/en/hotel-reviews/' + hotelNumber + '.html?stop_mobi=yes');
      };

      /**
      * bookStay
      *
      * Redirect user to Booking path.
      */
      $scope.bookStay = function () {
        //
        // Route to Hotel Search
        routingService.goToHotelSearch(true);
      };


      /**
      * accountSummary
      *
      * Redirect user to their account summary
      */
      $scope.accountSummary = function () {
        //
        // Route to Account Summary
        routingService.goToAccountSummary();
      };

      function init() {
          //
          // After checkout, remove eligibility
        mobileCheckoutModel.setEligibility(false);
        mobileCheckoutModel.reset();
        activeStaysModel.reset();
          //
          // Don't check again for 12 hours.
        localStorageService.setValue('lqApp.Checkout.Timeout', new Date().getTime() + (12 * 3600 * 1000));
      }


      init();
    }]
);
