/* global lqMobileModule*/
lqMobileModule.factory('HotelSummary', function () {
  'use strict';

  /* Constructor */
  function HotelSummary(summaryObj) {
    this.hotelSummary = {
      address: {
        city: summaryObj.hotelAddress.city,
        countryCode: summaryObj.hotelAddress.countryCode,
        countryDisplay: summaryObj.hotelAddress.countryDisplay,
        county: summaryObj.hotelAddress.county,
        postalCode: summaryObj.hotelAddress.postalCode,
        stateProvince: summaryObj.hotelAddress.stateProvince,
        stateProvinceDisplay: summaryObj.hotelAddress.stateProvinceDisplay,
        street: summaryObj.hotelAddress.street
      },
      innNumber: {
        id: summaryObj.hotelId
      },
      location: {
        latitude: summaryObj.geoLocation.latitude,
        longitude: summaryObj.geoLocation.longitude
      },
      name: summaryObj.name,
      ratingImageUrl: summaryObj.hotelRating.imageURL.replace(/(^https?:)/i, ''),
      primaryPhoneNumber: {
        countryCode: summaryObj.phoneCountryCode,
        areaCode: summaryObj.phoneAreaCode,
        number: summaryObj.phoneNumber
      }
    };
    this.range = {
      range: 0
    };
  }

  /* Static call on object for an PointsSummary */
  HotelSummary.build = function (summaryObj) {
    return new HotelSummary(summaryObj);
  };

  /**
   * Return the constructor function
   */
  return HotelSummary;
});
