/* global lqMobileModule, lqMobile*/
lqMobileModule.factory('UserActivity', ['lodash', function (lodash) {
  'use strict';

  /* Constructor */
  function UserActivity() {
    this.date = null;
    this.description = null;
    this.description2 = null;
    this.points = null;
    this.quantity = null;
    this.returnsNumber = null;
    this.orderId = null;
    this.type = null;
    this.earnedRewardType = null;
    this.innNumber = null;
    this.nights = null;
  }

  UserActivity.build = function () {
    return new UserActivity();
  };

  UserActivity.map = function (activityObj) {
    var userActivity = UserActivity.build();

    userActivity.date = lodash.get(activityObj, 'date', null);

    userActivity.description = lodash.get(activityObj, 'description', null);
    userActivity.points = lodash.get(activityObj, 'points', 0);
    userActivity.quantity = lodash.get(activityObj, 'quantity', 0);
    userActivity.returnsNumber = lodash.get(activityObj, 'returnsNumber.id', null);
    userActivity.orderId = lodash.get(activityObj, 'orderId', null);
    userActivity.type = lodash.get(activityObj, 'type', null);
    userActivity.earnedRewardType = lodash.get(activityObj, 'earnedRewardType', null);
    userActivity.innNumber = lodash.get(activityObj, 'innNumber.id', null);
    userActivity.nights = lodash.get(activityObj, 'nights', 0);

    return userActivity;
  };

  /**
   * Return the constructor function
   */
  return UserActivity;
}]);
