/* global lqMobileModule*/
/* jshint maxparams: 10 */
lqMobileModule.factory('StoredPhone', ['lodash', function (lodash) {
  'use strict';

    /* Constructor */
  function StoredPhone(
    phoneDesignation, country, countryCode, areaCode, number, primary
  ) {
    this.phoneDesignation = phoneDesignation;
    this.phoneNumber = {
      areaCode: null,
      country: null,
      countryCode: null,
      number: null
    };
    this.primary = primary;
    this.notificationOptIns = [];
  }

    /* Static call on object */
  StoredPhone.build = function (
    phoneDesignation, country, countryCode, areaCode, number, primary, notifications
  ) {
    return new StoredPhone(
      phoneDesignation, country, countryCode, areaCode, number, primary, notifications
    );
  };

  StoredPhone.isNumberValid = function (number) {
    return !lodash.isUndefined(number) && !lodash.isNull(number) && number.length > 0;
  };

    /**
     * Return the constructor function
     */
  return StoredPhone;
}]);
