/* global lqMobileModule, LQMobile */
/* jshint maxparams: 10 */
/* jshint maxstatements: 50 */
lqMobileModule.factory('ConvertHold', function () {
  'use strict';

    /* Constructor */
  function ConvertHold() {
    this.channel = 'MOBILE_APP';
    this.arrivalDate = null;
    this.departureDate = null;
    this.iata = null;
    this.innNumber = {
      id: null
    };
    this.mainContact = {
      emailAddress: [],
      suffix: '',
      firstName: null,
      lastName: null,
      middleName: '',
      phoneNumbers: [],
      postalAddress: null,
      returnsNumber: null,
      guestSpecialRequest: null
    };
    this.paymentInfo = [];
    this.quotedTotalRate = {
      amount: null,
      currencyCode: null
    };
    this.quotedTotalRateWithTaxes = {
      amount: null,
      currencyCode: null
    };
    this.rateQualifier = null;
    this.roomReservations = null;
    this.specialRequests = null;
    this.language = {
      code: 'en'
    };
    this.confirmationNumber = {
      number: null
    };
    this.arrivalTimeCode = {
      name: null,
      description: null
    };
  }

    /* Static call on object for a plain reservation request */
  ConvertHold.build = function () {
    return new ConvertHold();
  };

    /* Static call on object for a reservation request for a normal booking path*/
  ConvertHold.buildConvertHold = function (
    searchData, mainContact, paymentInfoArray, hotelData, hold
  ) {
    var reservation = new ConvertHold();
    var roomReservation = {};
    var phoneNumbersLength;
    var index;
    var phoneNumber;

    reservation.arrivalDate = LQMobile.Util.dateToString(searchData.checkinDate);
    reservation.departureDate = LQMobile.Util.dateToString(searchData.checkoutDate);
    reservation.innNumber.id = hotelData.hotelDetails.hotelId;
    reservation.mainContact = mainContact;

    if (reservation.mainContact.phoneNumbers) {
      phoneNumbersLength = reservation.mainContact.phoneNumbers.length;
      for (index = 0; index < phoneNumbersLength; index += 1) {
        phoneNumber = reservation.mainContact.phoneNumbers[index];
        if (phoneNumber.phoneDesignation === 'MOBILE') {
          phoneNumber.notifications = [{ code: 'InstantHold', description: 'InstantHold' }];
        }
        phoneNumber.phoneNumber.countryCode = '1';
      }
    }
    reservation.paymentInfo = paymentInfoArray;
    reservation.quotedTotalRate = hold.quotedTotalRate;
    reservation.quotedTotalRateWithTaxes = hold.quotedTotalRateWithTaxes;
    reservation.rateQualifier = hold.rateQualifier;
    reservation.roomReservations = hold.roomReservations;
    roomReservation.numberOfAdults = searchData.numberOfAdults;
    roomReservation.numberOfChildren = searchData.numberOfChildren;
    roomReservation.numberOfRooms = searchData.numberOfRooms;
    roomReservation.roomReservations = hold.roomReservations;
    roomReservation.nightlyRoomRates = hold.nightlyRates;
    reservation.confirmationNumber.number = hold.confirmationNumber;

    reservation.arrivalTimeCode.name = 'T1 - Before 12PM';
    reservation.arrivalTimeCode.description = 'before noon';

    return {
      Reservation: reservation
    };
  };

    /**
     * Return the constructor function
     */
  return ConvertHold;
});
