/* global lqMobileModule, google*/
lqMobileModule.factory('omniBoxEndpointService', ['$q', '$http', 'serviceEndPoints',
  function ($q, $http, serviceEndPoints) {
    'use strict';

    var endpointService = {};

    endpointService.addAutocomplete = function () {
      return new google.maps.places.AutocompleteService();
    };

    endpointService.addGeocoder = function () {
      return new google.maps.Geocoder();
    };

    endpointService.geoLocateAddress = function (geocoder, address) {
      var deferred = $q.defer();

      geocoder.geocode({
        address: address
      }, function (results, status) {
        if (status === google.maps.GeocoderStatus.OK) {
          deferred.resolve(results[0]);
        } else {
          deferred.reject('Geocode was not successful for the following reason: ' + status);
        }
      });

      return deferred.promise;
    };

    endpointService.getDestinationsAutoComplete = function (locationFirstChar) {
      return $http({
        method: 'get',
        url: serviceEndPoints.getDestinationsAutoCompleteEndPoint(locationFirstChar)
      }).then(
        function (response) {
          return response.data;
        },
        function (error) {
          throw error;
        }
      );
    };

    return endpointService;
  }]);
