/* global lqMobileModule, $*/
lqMobileModule.controller('hotelInformationPartialController',
  ['$scope', 'routingService', 'searchParamModelService', 'reservationsModel', 'hotelInformationModel', 'bookingModelService', 'editSearchPanelCollapseFactory', 'hotelRoomsModel',
    function ($scope, routingService, searchParamModelService, reservationsModel, hotelInformationModel, bookingModelService, editSearchPanelCollapseFactory, hotelRoomsModel) {
      'use strict';

      $scope.searchData = searchParamModelService.data;

      $scope.doLocationSearch = function () {};
      $scope.doFindHotels = function () {
        if (reservationsModel.data.selectedFullReservation) {
          hotelRoomsModel.getAvailableRooms();
        } else {
          routingService.goToHotelSearch();
        }
      };

      // collapse the edit search panel when starts.
      editSearchPanelCollapseFactory.collapsePanel();

      // if there was a selected reservation and the user selected to change
      // it but then picked a different hotel, remove the selected reservation
      if (
        reservationsModel.data.selectedFullReservation &&
        reservationsModel.data.selectedFullReservation.hotelId !==
          hotelInformationModel.data.hotelDetails.hotelId
      ) {
        reservationsModel.clearModel();
      }

      // clear the confirmation number (from possible previous reservation)
      bookingModelService.resetConfirmationNumber();
    }]);
