/* global lqMobileModule*/
/* jshint maxparams: 10 */
lqMobileModule.controller('myReservationsController',
  [
    '$scope',
    '$filter',
    '$rootScope',
    'reservationsModel',
    'returnsUserProfileModel',
    'routingService',
    'searchParamModelService',
    'events',
    'satelliteTrackingModelService',
    function (
      $scope,
      $filter,
      $rootScope,
      reservationsModel,
      returnsUserProfileModel,
      routingService,
      searchParamModelService,
      events,
      satelliteTrackingModelService
    ) {
      'use strict';

      $scope.reservations = reservationsModel.data;

      $scope.selectHotel = function (reservation) {
    // $rootScope.$broadcast(events.bookThisHotelLinkSelected);
        satelliteTrackingModelService.bookThisHotelLinkSelected();
        if (reservation.status === 'CONFIRMED') {
          searchParamModelService.data.checkinDate = reservation.arrivalDate;
          searchParamModelService.data.checkoutDate = reservation.departureDate;
        }
        searchParamModelService.data.currentPlace = '';
        searchParamModelService.data.resultsViewType = 'list';
        $scope.loadHotelDetails(reservation.hotelId, reservation.hotelCity + ', ' + reservation.hotelStateProvinceDisplay);
      };

      $scope.confirmedOrHold = function (reservation) {
        return (reservation.status === 'CONFIRMED' || reservation.status === 'ONHOLD');
      };

      $scope.checkedOrCancelled = function (reservation) {
        return (reservation.status === 'CHECKOUT' || reservation.status === 'CANCELLED');
      };

      $scope.viewReservation = function (reservation) {
    // $rootScope.$broadcast(events.viewBookingDetailsButtonSelected);
        satelliteTrackingModelService.viewBookingDetailsButtonSelected();

        reservationsModel.setSelectedReservation(reservation);
        routingService.goToReservationDetails();
      };

      function initializeReservations() {
        $scope.loading = true;
        reservationsModel.initializeReservations().then(function () {
          $scope.loading = false;
        }, function (error) {
          $scope.servicesError = error;
          $scope.loading = false;
        });
      }

      initializeReservations();
  // $rootScope.$broadcast(events.myReservationsLoaded);
      satelliteTrackingModelService.myReservationsLoaded();
    }]);
