/* global lqMobileModule*/
/* jshint maxparams: 10 */
lqMobileModule.controller('forgotPassModalInstanceController', ['$scope',
  '$modalInstance',
  'returnsUserProfileModel',
  'routingService',
  'showLoadingModal',
  'satelliteTrackingModelService',
  function (
    $scope,
    $modalInstance,
    returnsUserProfileModel,
    routingService,
    showLoadingModal,
    satelliteTrackingModelService
  ) {
    'use strict';

    $scope.showForgotPasswordForm = false;

    $scope.enableForgotPasswordForm = function () {
      satelliteTrackingModelService.forgotPwdLinkSelected();
      $scope.showForgotPasswordForm = true;
      satelliteTrackingModelService.changePasswordModalLoaded();
    };

    $scope.resetForm = {};
    $scope.resetForm.userId = '';
    $scope.resetForm.firstName = '';
    $scope.resetForm.lastName = '';
    $scope.resetForm.mobilePhone = '';
    $scope.resetForm.formSubmitted = false;
    $scope.resetForm.formSubmittedOk = false;
    $scope.resetForm.submitDisabled = false;
    $scope.resetForm.isFormValid = false;
    $scope.resetForm.servicesError = '';

    $scope.resetForm.submitForm = function (isFormValid) {
      $scope.resetForm.isFormValid = isFormValid;
      $scope.resetForm.formSubmitted = true;
      $scope.resetForm.submitDisabled = true;
      if (isFormValid) {
        $scope.resetForm.loadingModal = showLoadingModal();
        $scope.resetForm.servicesError = '';
        returnsUserProfileModel.resetUserPassword(
          $scope.resetForm.userId, $scope.resetForm.firstName,
          $scope.resetForm.lastName, $scope.resetForm.mobilePhone
        ).then(function () {
          $scope.resetForm.formSubmittedOk = true;
          $scope.resetForm.formSubmitted = false;
          $scope.resetForm.loadingModal.close();
        }, function (error) {
          $scope.resetForm.servicesError = error;
          $scope.resetForm.loadingModal.close();
        });
      } else {
        $scope.resetForm.submitDisabled = false;
      }
    };

    $scope.cancel = function () {
      $modalInstance.dismiss('cancel');
    };

    $scope.getFormFieldCssClass = function (isFieldValid) {
      if ($scope.resetForm.formSubmitted && !isFieldValid) {
        return 'has-error';
      }
      return '';
    };
  }]);
