/* global lqMobileModule, CQ*/
lqMobileModule.controller('returnsActivityController', ['$scope', 'returnsUserProfileModel', '$sce',
  function ($scope, returnsUserProfileModel, $sce) {
    'use strict';

    $scope.userData = returnsUserProfileModel.data;
    $scope.monthsBack = 12;
    $scope.servicesError = '';
    $scope.loadingData = true;
    $scope.trustAsHtml = $sce.trustAsHtml;

    function loadUserActivities() {
      var token = window.sessionStorage.getItem('token');

      $scope.servicesError = '';
      $scope.loadingData = true;
      $scope.loadingModal = $scope.showLoadingModal();
      returnsUserProfileModel.getUserActivities($scope.monthsBack, token).then(function () {
        $scope.loadingModal.close();
        $scope.loadingData = false;
      }, function (error) {
        // Change the error message if services changes this
        $scope.servicesError = CQ.I18n.getMessage(error.message);
        $scope.loadingModal.close();
        $scope.loadingData = false;
      });
    }

    $scope.init = function (monthsBack) {
      $scope.monthsBack = monthsBack;
      loadUserActivities();
    };
  }]);
