/* global lqMobileModule, console*/
lqMobileModule.controller('returnsChangePasswordController', [
  '$scope',
  '$modal',
  '$log',
  'returnsUserProfileModel',
  'satelliteTrackingModelService',
  'secureStorageService',
  'touchIdService',
  function (
    $scope,
    $modal,
    $log,
    returnsUserProfileModel,
    satelliteTrackingModelService,
    secureStorageService,
    touchIdService
  ) {
    'use strict';

    $scope.changePassForm = {};
    $scope.changePassForm.currentPassword = '';
    $scope.changePassForm.newPassword = '';
    $scope.changePassForm.retypeNewPassword = '';
    $scope.userProfile = returnsUserProfileModel.data.userProfile;
    $scope.changePassForm.formSubmitted = false;

    $scope.areDifferentPasswords = function () {
      return $scope.changePassForm.newPassword
        && $scope.changePassForm.retypeNewPassword
        && $scope.changePassForm.newPassword !== $scope.changePassForm.retypeNewPassword;
    };

    $scope.changePassForm.submitForm = function (isFormValid) {
      var authToken = window.sessionStorage.getItem('token');
      $scope.changePassForm.formSubmitted = true;
      $scope.changePassForm.serviceErrors = '';
      $scope.changePassForm.inputErrors = '';
      if (isFormValid) {
        $scope.loadingModal = $scope.showLoadingModal();
        returnsUserProfileModel.changeUserPassword($scope.userProfile.returnsNumber,
                $scope.changePassForm.currentPassword, $scope.changePassForm.newPassword, authToken).then(
                    function () {
                      $scope.loadingModal.close();
                      $scope.open();
                      secureStorageService.setValue('password', $scope.changePassForm.newPassword);
                      touchIdService.userIsUsingFingerAuth($scope.userProfile.returnsNumber).then(
                        function (response) {
                          if (response.isUsing && response.isCurrent) {
                            touchIdService.registerWithFingerAuthentication(
                              $scope.userProfile.returnsNumber, $scope.userProfile.lastName,
                              $scope.changePassForm.newPassword
                            ).then(
                              function (isSuccess) {
                                // success
                                if (!isSuccess) {
                                  touchIdService.setUsingFingerAuth(false);
                                  navigator.notification.alert(
                                    'Failed To Store New Password For Fingerprint Login, Fingerprint Login Disabled',
                                    function () {},
                                    'An Error Has Occurred!'
                                  );
                                }
                                // if isSuccess, do nothing, everything stored correctly
                              },
                              function () {
                                // failed
                                touchIdService.setUsingFingerAuth(false);
                                touchIdService.touchIdFailureMessage();
                              }
                            );
                          }
                        },
                        function () {
                          // not using
                        }
                      );
                    },
                    function (error) {
                      $scope.loadingModal.close();
                      console.error('change password error');
                      console.error(error);
                      $scope.changePassForm.serviceErrors = CQ.I18n.getMessage(error);
                    }
                );
      }
    };

    $scope.open = function () {
      $modal.open({
        templateUrl: 'returnsChangePasswordModal.html',
        controller: 'returnsChangePasswordModalController',
        windowClass: 'app-modal-window border-radius'
      });
    };
    satelliteTrackingModelService.changePasswordLoaded();
  }]);

lqMobileModule.controller('returnsChangePasswordModalController', ['$scope', '$modalInstance', 'routingService', 'satelliteTrackingModelService',
  function ($scope, $modalInstance, routingService, satelliteTrackingModelService) {
    'use strict';

    $scope.ok = function () {
      $modalInstance.dismiss('ok');
      routingService.goToAccountSummary();
    };
    satelliteTrackingModelService.changePasswordModalLoaded();
  }]);
