/* global lqMobileModule*/
lqMobileModule.controller('returnsSummaryController',
  [
    '$scope',
    '$rootScope',
    '$window',
    'returnsUserProfileModel',
    'routingService',
    'events',
    'satelliteTrackingModelService',
    function ($scope,
      $rootScope,
      $window,
      returnsUserProfileModel,
      routingService,
      events,
      satelliteTrackingModelService) {
      'use strict';

      if (returnsUserProfileModel.isLoggedIn()) {
        $scope.returnsSummary = returnsUserProfileModel;
        $scope.firstName = returnsUserProfileModel.data.userProfile.firstName;
        $scope.lastName = returnsUserProfileModel.data.userProfile.lastName;
        $scope.accountBalance =
          returnsUserProfileModel.data.userProfile.pointsSummary.currentPointsBalance;
        $scope.nightsToNextMemberLevel =
          returnsUserProfileModel.data.userProfile.pointsSummary.nightsToNextMemberLevel;
        $scope.accountAdjustments =
          returnsUserProfileModel.data.userProfile.pointsSummary.accountAdjustments;
        $scope.pointsEarnedYTD =
          returnsUserProfileModel.data.userProfile.pointsSummary.pointsEarnedYTD;
        $scope.bonusPointsYTD =
          returnsUserProfileModel.data.userProfile.pointsSummary.bonusPointsYTD;
        $scope.pointsRedeemedYTD =
          returnsUserProfileModel.data.userProfile.pointsSummary.pointsRedeemedYTD;

        if (typeof returnsUserProfileModel.data.userProfile.pointsSummary.staysToNextMemberLevel !== 'undefined') {
          $scope.staysToNextMemberLevel =
            returnsUserProfileModel.data.userProfile.pointsSummary.staysToNextMemberLevel;
        } else {
          $scope.staysToNextMemberLevel = 0;
        }

        if (typeof returnsUserProfileModel.data.userProfile.returnsTier === 'string') {
          $scope.returnsTier = returnsUserProfileModel.data.userProfile.returnsTier.toUpperCase();
        } else {
          $scope.returnsTier = 'NO TIER';
        }
      } else {
        routingService.goToSignInPage();
      }

      $scope.suppressNightsToNextMemberLevel = function () {
        return $scope.returnsTier === 'ELITE';
      };

      $scope.showStaysToNextMemberLevel = function () {
        return $scope.staysToNextMemberLevel > 0 && $scope.returnsTier !== 'ELITE';
      };

      $scope.logout = function () {
        returnsUserProfileModel.logoutUser();
        $rootScope.$broadcast(events.logoutLinkSelected);
        routingService.goToSignInPage(true);
        returnsUserProfileModel.skipNextFingerprint = true;
      };

      $scope.editProfile = function () {
        routingService.goToEditProfile();
      };

      $scope.changePassword = function () {
        routingService.goToChangePassword();
      };

      satelliteTrackingModelService.returnsAccountSummaryLoaded();
    }]);
