/* global lqMobileModule */
/**
 * Created by rjones on 8/23/16.
 */
lqMobileModule.factory('urlService', function () {
  'use strict';

  var service = {};
    /*
    * openExternalUrl
    *
    * detects the device platform and opens the url externally
    *
    * available after deviceReady
    *
    * This REQUIRES Cordova InAppBrowser plugin:
    * http://cordova.apache.org/docs/en/latest/reference/cordova-plugin-inappbrowser/index.html
    *
    * @param {string} [url]
    * */
  service.openExternalUrl = function (url) {
    if (device.platform.toUpperCase() === 'ANDROID') {
      navigator.app.loadUrl(url, { openExternal: true });
    } else {
      cordova.InAppBrowser.open(url, '_system');
    }
  };

    /*
    * handleLinksExternally
    *
    * This will make sure that all links that start with 'http' on click open in external browser
    * */
  service.handleLinksExternally = function () {
    var hrefElements = 'a[href^="http"], a[href^="uber"], a[href^="com.uber"]'; // links that start with http(s),com.uber or uber://

    $(document).on('click', hrefElements, function (e) {
      var url = $(this).attr('href');
      service.openExternalUrl(url);
      e.preventDefault();
    });
  };

  return service;
});
