/**
 * Created by jeffrey on 1/25/17.
 */
lqMobileModule.factory(
    'localStorageService',
  [
    function () {
      var thisService = {};
      var LOCAL_STORAGE_PREFIX = 'lqAppLocal_';

      function isJsonString(str) {
        if (typeof str === 'string') {
          try {
            JSON.parse(str);
          } catch (e) {
            return false;
          }
          return true;
        }
        return false;
      }

      /**
       * @param key
       *
       * @return {Object|String}
       */
      thisService.getValue = function (key) {
        var value = window.localStorage.getItem(LOCAL_STORAGE_PREFIX + key);
        return isJsonString(value) ? JSON.parse(value) : value;
      };

      /**
       * @param key
       */
      thisService.removeValue = function (key) {
        window.localStorage.removeItem(LOCAL_STORAGE_PREFIX + key);
      };

      /**
       * @param key
       * @param value
       *
       * @return {Promise<bool>,failure<string>}
       */
      thisService.setValue = function (key, value) {
        value = JSON.stringify(value);
        window.localStorage.setItem(LOCAL_STORAGE_PREFIX + key, value);
      };

      return thisService;
    }
  ]
);
