/* global lqMobileModule, $, LQMobile, CQ*/
lqMobileModule.factory('editSearchPanelCollapseFactory', ['$location', '$rootScope', 'events', 'satelliteTrackingModelService',
  function ($location, $rootScope, events, satelliteTrackingModelService) {
    'use strict';

    var editSearchPanelCollapseFactory = {};

    editSearchPanelCollapseFactory.isCollapsed = true;
    editSearchPanelCollapseFactory.toggleLabel = CQ.I18n.getMessage('Edit');

    editSearchPanelCollapseFactory.toggleSearchEditPanel = function () {
      editSearchPanelCollapseFactory.isCollapsed = !editSearchPanelCollapseFactory.isCollapsed;
      LQMobile.Util.changeCssAttr('.hotelSearchConfig .omnibox-inner-container', 'display', editSearchPanelCollapseFactory.isCollapsed ? 'none' : 'block');
      if (editSearchPanelCollapseFactory.isCollapsed) {
        editSearchPanelCollapseFactory.toggleLabel = CQ.I18n.getMessage('Edit');
      } else {
        satelliteTrackingModelService.editSearchLinkSelected();
        editSearchPanelCollapseFactory.toggleLabel = CQ.I18n.getMessage('Close');
      }
      LQMobile.Util.changeCssAttr('.toggleOnEditSearch', 'display', editSearchPanelCollapseFactory.isCollapsed ? 'block' : 'none');
      if (editSearchPanelCollapseFactory.isCollapsed) {
        $location.search('editSearch', null);
      } else {
        $location.search('editSearch', true);
      }
    };

    editSearchPanelCollapseFactory.collapsePanel = function () {
      editSearchPanelCollapseFactory.isCollapsed = true;
      LQMobile.Util.changeCssAttr('.hotelSearchConfig .omnibox-inner-container', 'display', 'none');
      editSearchPanelCollapseFactory.toggleLabel = CQ.I18n.getMessage('Edit');
      LQMobile.Util.changeCssAttr('.toggleOnEditSearch', 'display', 'block');
      $location.search('editSearch', null);
    };

    editSearchPanelCollapseFactory.expandPanel = function () {
      editSearchPanelCollapseFactory.isCollapsed = false;
      LQMobile.Util.changeCssAttr('.hotelSearchConfig .omnibox-inner-container', 'display', 'block');
      editSearchPanelCollapseFactory.toggleLabel = CQ.I18n.getMessage('Close');
      LQMobile.Util.changeCssAttr('.toggleOnEditSearch', 'display', 'none');
      $location.search('editSearch', true);
    };

    return editSearchPanelCollapseFactory;
  }]);
